/*******************************************************************************
*
* File:         S20_demo.c
* Description:  ϵͳļ
* Version:      V0.1
* Date:         2020-02-22
* Author:       Tempest
 *******************************************************************************/

#include "ap_demo.h"
#include "ArmCM0.h"
#include "tau_device_datatype.h"
#include "tau_log.h"
#include "tau_operations.h"
#include "tau_common.h"
#include "tau_delay.h"
#include "hal_dsi_rx_ctrl.h"
#include "hal_dsi_tx_ctrl.h"
#include "hal_swire.h"
#include "hal_timer.h"
#include "hal_system.h"
#include "hal_gpio.h"
#include "hal_pwm.h"
#include "app_tp_st_touch.h"


#include "app_tp_transfer.h"
#ifdef LOG_TAG
    #undef LOG_TAG
#endif
#define LOG_TAG "S20U_NT37701"

/*****************************************/

//S8 MIPIϢ
/* ֱ */
#define INPUT_WIDTH  1080
#define INPUT_HEIGHT 2400
/*  MIPI lane rate,video modeҪȷãcmd mode */
#define INPUT_MIPI_LANE_RATE    1200000000  //898000000  1.2G
/* ͼʽ */
#define INPUT_COLOR_MODE DSI_RGB888
/* ݸʽ(DSI_DATA_CMD_MODE , DSI_DATA_VIDEO_MODE) */
#define INPUT_DATA_MODE DSI_DATA_CMD_MODE
/* mipi lane(DSI_RX_LANE_x     xΪ1-4) */
#define INPUT_MIPI_LANE_NUM DSI_LANE_4
/* Ϊvideo mode ʱݸʽ */
#define INPUT_VIDEO_MODEL DSI_NONBURST_EVENT
/* ͨ(0-3) */
#define INPUT_VC DSI_VC_0
/* ֡(60/90/120/144Hz) */
#define INPUT_FRAME_RATE DSI_FRAME_RATE_120HZ
/* ǷDSCѹ */
#define INPUT_COMPRESS true

#if AMOLED_NT37701_CSOT667

    /* ֱ */
   #define OUTPUT_WIDTH   1080
    #define OUTPUT_HEIGHT 2400
    /* ͨ(0-3) */
    #define OUTPUT_VC DSI_VC_0
    /* mipi lane(DSI_RX_LANE_x     xΪ1-4) */
    #define OUTPUT_LANE_NUMBER DSI_LANE_4
    /* Ϊvideo mode ݸʽ */
    #define OUTPUT_VIDEO_MODEL DSI_BURST_MODE
 	
	#define OUTPUT_VSA  8//4
    /*  VBP */
    #define OUTPUT_VBP  8
    /*  VBP */
    #define OUTPUT_VFP  56//72
    /*  VSA */
    #define OUTPUT_HSA  8
    /*  HBP */
    #define OUTPUT_HBP  12//92
    /*  HFP */
    #define OUTPUT_HFP  120//100
    /* ʼģʽ */
	#define _CMD_TYPE            DSI_CMD_TX_LP      //0-HS,1-LP;
#endif

#define SWIRE_TIMER          TIMER_NUM1
#define WAKE_UP_TIMER        TIMER_NUM2
#define ENABLE_TP_WAKE_UP    true
#define SWIRE_MAX_NUM        24

#define USE_FIRST_CODE       1      //S20Pִ,0ʾǵڶĴ
#define ADD_TP_CALIBRATION   1      //TPУ׼
#define AUTO_CAL_TP          0

//#define DISPLAY_ONLY
#define CUS_SCLD_FILTER true
#define NEW_ACK_CMD_FUNC true

/******************************************************/
static hal_dsi_rx_ctrl_handle_t *g_rx_ctrl_handle = NULL;
static hal_dsi_tx_ctrl_handle_t *g_tx_ctrl_handle = NULL;

#ifdef USE_FOR_SUMSUNG_S20
//S20  SWIRE=50->ELVSS=-1.7V
#define SWIRE_DEFAULT_NUM       50
#else
#define SWIRE_DEFAULT_NUM       38
#endif

#define SYNC_LIN_NUMBER         2400 //2400

static uint8_t swire_num=SWIRE_DEFAULT_NUM;

/* Ĭfalse,ʼ־λ,ʹTP1.8V,AC ʼҪTP1.8Vе */
static volatile bool start_display_on = true;

#if ENABLE_TP_WAKE_UP
static bool g_need_enter_sleep_mode = false;
#endif

static bool g_mipi_path_off = false;
extern bool s_screen_init_complate;

static uint8_t phone_off_flag =0;     	//绰ϨFLAG=1Ϩ
static bool g_exit_sleep_mode = false;

/* ʼɱ־λ */
static bool panel_display_done = false;
//static bool g_panel_init_done = false;
static volatile bool g_resolution_change = false;
static void swire_init(void);
static void soft_disable_mipi_timer_init(void);
void Gpio_swire_output(uint8_t flag, uint8_t num);

static bool phone_power_on = false;

#if AUTO_CAL_TP
static uint16_t g_cal_cnt = 100;    //3sʱTPУ׼
#endif

#ifdef USE_FOR_SUMSUNG_S20U
extern uint8_t Flag_blacklight_EN;
extern uint8_t tp_sleep_in;
extern uint8_t tp_sleep_count;
#endif

#ifdef USE_FOR_SUMSUNG_S20U
uint8_t phone_DoubleDlick_flag=0;
uint8_t phone_86_flag=0;
uint8_t phone_A6_flag=0;
uint8_t phone_start_flag=0;
uint16_t phone_DisplayOFF_count=0;
uint8_t phone_DisplayOFF_flag=0;
#endif

#if ADD_TP_CALIBRATION
static volatile bool g_calibration_flag = false;
#endif

static uint32_t test_count =1;

uint32_t s_heartbeat = 0;

 
void blue_change_ccm(void)
{
	ccm_coef_t ccm;
	ccm.coef_c00 = 250;	// 260
	ccm.coef_c01 = 0;
	ccm.coef_c02 = 0;
	ccm.coef_c10 = 0;
	ccm.coef_c11 = 256;	// 250
	ccm.coef_c12 = 0;
	ccm.coef_c20 = 0;
	ccm.coef_c21 = 0;
	ccm.coef_c22 = 256;  //260

	hal_dsi_tx_ctrl_set_ccm(ccm);
}


static bool ap_dcs_read(uint8_t data_type, uint8_t dcs_cmd, uint8_t param)
{
#ifdef USE_FOR_SUMSUNG_S20U
	static uint8_t b3_read_flag =0;
	static uint8_t c8_read_flag =0;
	static uint8_t c9_read_flag =0;
	static uint8_t c9_read_flag2 =0;
	static uint8_t c9_read_flag3 =0;

	uint32_t return_size = hal_dsi_rx_ctrl_get_max_ret_size(g_rx_ctrl_handle);
//	TAU_LOGD("r[%x] [%d]", dcs_cmd, return_size);
	
	if (dcs_cmd == 0xDA)
	{
		phone_DisplayOFF_flag=1;
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
									 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
									 DSI_VC_0,
									 0x1, 0x81);
  phone_power_on = true;
	}
	else if (dcs_cmd == 0xDB)
	{
		phone_DisplayOFF_flag=1;	  
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
									DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
									DSI_VC_0,
									0x1, 0x21);   //0x1, 0x01);   
 
	}
	else if (dcs_cmd == 0xDC)
	{
		  phone_DisplayOFF_flag=1;		
		  hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
										 DSI_VC_0,
										 0x1, 0x04);  //0x1, 0x03);   

	}
	else if (dcs_cmd == 0x01)
	{
      ap_get_tp_calibration_status_01(g_rx_ctrl_handle, param);
	}
	else if (dcs_cmd == 0x04)
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
									 DSI_ACK_DT_DSC_LONG_RESPONSE,
									 DSI_VC_0,
									 3, 0x81,0x01,0x03);
	}
	else if (dcs_cmd == 0x0A)
	{
		if (return_size == 3)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 3, 0x9D,0x9D,0x9D);
		}
		else
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
											 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
											 DSI_VC_0,
											 0x1, 0x9F);
		}
	}
	else if (dcs_cmd == 0x0E)
	{
		  hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
										 DSI_VC_0,
										 0x1, 0x80);   
	}
	else if (dcs_cmd == 0x0F)
	{
		  hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
										 DSI_VC_0,
										 0x1, 0xC0);   
	}
	else if (dcs_cmd == 0xEE)
	{
		  hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
										 DSI_VC_0,
										 0x1, 0x00);   
	}
	else if (dcs_cmd == 0x05)
	{
		  hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
										 DSI_VC_0,
										 0x1, 0x00);   
	}
	else if (dcs_cmd == 0x87)
	{
		  hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
										 DSI_VC_0,
										 0x1, 0x00);   
	}
	else if (dcs_cmd == 0xA1)
	{
		if (return_size == 11)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 return_size, 0x0B,0xF2,0x0C,0x90,0x9B,0x17,0x0D,0x05,0x0D,0x20,0xBF);
										
		}
		else if (return_size == 10)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 //10, 0x0B,0xF2,0x0C,0x90,0x9B,0x17,0x0D,0x05,0x0D,0x20);
									     10, 0x0B,0xF6,0x0C,0x91,0x93,0x0D,0x09,0x15,0x03,0x1A); 

										
		}
		else if (return_size == 4)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 4, 0x0B,0xF2,0x0C,0x90);
										
		}
		else if (return_size == 1)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
										 DSI_VC_0,
										 1, 0x30);  //1, 0xBF);
		}
		else
		{
			TAU_LOGD("r[%x] [%d] err", dcs_cmd, return_size);
		}
	}
	else if (dcs_cmd == 0xD6)
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
									 DSI_ACK_DT_DSC_LONG_RESPONSE,
									 DSI_VC_0,
									 //5, 0x98,0x8E,0xB1,0x79,0x9A);	
									 5, 0x9B,0x8A,0x35,0x60,0xC2);  
		
	}
	else if (dcs_cmd == 0xEC)
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
									 DSI_ACK_DT_DSC_LONG_RESPONSE,
									 DSI_VC_0,
									 5, 0x00,0x00,0x00,0x00,0x00);
	}
	else if (dcs_cmd == 0x7F)
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
									 DSI_ACK_DT_DSC_LONG_RESPONSE,
									 DSI_VC_0,
									 10, 0x40,0x04,0x00,0x00,0x00,0x00,0x3A,0x9B,0x74,0xB0);
	}
	else if (dcs_cmd == 0xFE)
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
									 DSI_ACK_DT_DSC_LONG_RESPONSE,
									 DSI_VC_0,
									 10, 0x30,0x08,0x00,0x31,0x00,0x00,0x00,0x00,0x00,0x10);
	}
	else if (dcs_cmd == 0x5A)
	{
		static uint8_t flag_5a =0;
		if (flag_5a==0)
		{
			flag_5a =1;
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 41, 0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
										 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
		}
		else
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 41, 0x01,0x00,0x01,0x01,0x3B,0x01,0x3B,0x00,0x03,0x01,0x1F,0x00,0xE8,0x00,0xE7,0x00,0xEE,0x00,0x9D,0x00,
										 0x85,0x00,0xAB,0x00,0x9D,0x00,0x85,0x00,0xAB,0x00,0x9D,0x00,0x85,0x00,0xAB,0x00,0x9D,0x00,0x85,0x00,0xAB);
		}
	}
	else if (dcs_cmd == 0xB5)
	{
		if (return_size == 76)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 return_size,
										 0x19,0xDC,0x16,0x01,0x44,0x4C,0x7E,0x44,0xB0,0xE2,0x55,0x14,0x46,0x55,0x78,0xAA,0x56,0xDC,0x0E,0x66,
										 0x40,0x72,0x66,0xA4,0xD6,0x77,0x08,0x3A,0x77,0x6C,0x9E,0x70,0xD0,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
										 0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,0x11,0x12,0x13,0x14,0x14,0x14,0x14,0x14,0x14,0x14,0x14,
										 0x01,0x22,0x33,0x44,0x00,0x00,0x06,0x66,0xBB,0x0B,0x01,0x11,0x11,0x10,0x15,0x04);
		}
		else if (return_size == 75)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 return_size, 0x19,0xDC,0x16,0x01,0x44,0x4C,0x7E,0x44,0xB0,0xE2,0x55,0x14,0x46,0x55,0x78,0xAA,0x56,0xDC,0x0E,0x66,0x40,0x72,
										 0x66,0xA4,0xD6,0x77,0x08,0x3A,0x77,0x6C,0x9E,0x70,0xD0,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,
										 0x0F,0x10,0x11,0x12,0x13,0x14,0x14,0x14,0x14,0x14,0x14,0x14,0x14,0x01,0x22,0x33,0x44,0x00,0x00,0x06,0x66,0xBB,0x0B,0x01,0x11,0x11,0x10,0x15);
		}
		else if (return_size == 23)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 23, 0x19,0xDC,0x16,0x01,0x44,0x4C,0x7E,0x44,0xB0,0xE2,0x55,0x14,0x46,0x55,0x78,0xAA,0x56,0xDC,0x0E,0x66,0x40,0x72,0x66);
		}
		else if (return_size == 2)
		{
			c8_read_flag =0x20;  // C8B5棬־0x20
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_SHORT_RESPONSE_2B,
										 DSI_VC_0,
										 //2, 0x15, 0x04);
										 2, 0x13, 0x03);
		}
		else
		{
			TAU_LOGD("r[%x] [%d] err", dcs_cmd, return_size);
		}

	}
	else if (dcs_cmd == 0xC8)
	{
		if (return_size == 144)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 return_size,
										 0x00,0x6A,0x20,0xAF,0x5C,0x5A,0x5D,0x5E,0x5C,0x5F,0x49,0x44,0x4B,0x4C,0x46,0x50,0x5C,0x56,0x5E,0x56,0x50,
										 0x59,0x35,0x2F,0x3D,0x61,0x6A,0x66,0x66,0x74,0x6A,0x66,0x63,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
										 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
										 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
										 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
										 0x00,0x00,0x00,0x00,0x00,0x00,0x15,0xB1,0xB1,0xB0,0x7B,0x7A,0x7B,0x7A,0x79,0x7C,0x78,0x75,0x79,0x76,0x72,
										 0x77,0x75,0x72,0x78,0x74,0x6C,0x76,0x68,0x58,0x6E,0x78,0x76,0x79,0x74,0x81,0x78,0x22,0x20);
		}
		else if (return_size == 34)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 return_size,
										 0x00,0x6A,0x20,0xAF,0x5C,0x5A,0x5D,0x5E,0x5C,0x5F,0x49,0x44,0x4B,0x4C,0x46,0x50,0x5C,0x56,0x5E,0x56,0x50,
										 0x59,0x35,0x2F,0x3D,0x61,0x6A,0x66,0x66,0x74,0x6A,0x66,0x63,0x43);
		}
		else if (return_size == 10)
		{
			if ((c8_read_flag&0xF0) ==0x10) // C9/B3
			{
				if ((c8_read_flag&0x0F) ==0)
				{
					c8_read_flag |=0x01;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x00,0x6A,0x20,0xAF,0x5C,0x5A,0x5D,0x5E,0x5C,0x5F);
					                             10, 0x00,0x6A,0x1A,0xB9,0x5D,0x5B,0x5D,0x5B,0x59,0x5C);

				}
				else if ((c8_read_flag&0x0F) ==1)
				{
					c8_read_flag |=0x02;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x49,0x44,0x4B,0x4C,0x46,0x50,0x5C,0x56,0x5E,0x56);
					                             10, 0x4A,0x46,0x4C,0x4E,0x48,0x51,0x5B,0x56,0x5E,0x58);

				}
				else
				{
					c8_read_flag &= 0xF0;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x50,0x59,0x35,0x2F,0x3D,0x61,0x6A,0x66,0x66,0x74);
					                             10, 0x51,0x5A,0x3C,0x35,0x41,0x5F,0x68,0x66,0x63,0x70);

				}
			}
			else // if ((c8_read_flag&0xF0) ==0x20)  //B5
			{
				if ((c8_read_flag&0x0F) ==0)
				{
					c8_read_flag |=0x01;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x15,0xB1,0xB1,0xB0,0x7B,0x7A,0x7B,0x7A,0x79,0x7C);
					                             10, 0x15,0xB2,0xB2,0xB1,0x79,0x79,0x7A,0x7C,0x7A,0x7C);

				}
				else if ((c8_read_flag&0x0F) ==1)
				{
					c8_read_flag |=0x02;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x78,0x75,0x79,0x76,0x72,0x77,0x75,0x72,0x78,0x74);
					                             10, 0x77,0x75,0x79,0x75,0x71,0x77,0x78,0x73,0x79,0x75); 

				}
				else
				{
					c8_read_flag &= 0xF0;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x6C,0x76,0x68,0x58,0x6E,0x78,0x76,0x79,0x74,0x81);
					                             10, 0x6E,0x77,0x65,0x59,0x6E,0x78,0x75,0x79,0x5A,0x69);

				}
			}
			
		}
		else if (return_size == 4)
		{
			c9_read_flag =0x10;  // C9C8棬־0x10
			
			if ((c8_read_flag&0xF0) ==0x10)
			{
				hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
											 DSI_ACK_DT_DSC_LONG_RESPONSE,
											 DSI_VC_0,
											 //4, 0x6A,0x66,0x63,0x43);
				                             4, 0x68,0x66,0x63,0x43);

			}
			else
			{
				if (c9_read_flag2 >2)
					c8_read_flag =0x10;
				
				hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
											 DSI_ACK_DT_DSC_LONG_RESPONSE,
											 DSI_VC_0,
											 //4, 0x78,0x22,0x20,0x00);
				                             4, 0x67,0x22,0x20,0x00);

			}
		}
		else
		{
			TAU_LOGD("r[%x] [%d] err", dcs_cmd, return_size);
		}
//		c8_read_flag =0x00|(c8_read_flag&0x0F);  // C8C8棬־0x20
	}
	else if (dcs_cmd == 0xC9)
	{
		//ԭװеΪc9_read_flag=0X100X20ʱӦֵ
		if (return_size == 142)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 return_size,
										 0x00,0x31,0x01,0x01,0x9E,0x41,0x33,0x54,0x53,0x31,0x53,0x30,0x39,0x30,0x31,0x38,0x42,0x42,0x32,0x32,
										 0x35,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x15,0xAE,0xAE,
										 0xAD,0x7B,0x7A,0x7C,0x7B,0x79,0x7B,0x77,0x76,0x79,0x77,0x73,0x77,0x77,0x75,0x79,0x76,0x73,0x78,0x73,
										 0x72,0x76,0x82,0x83,0x7F,0x67,0x7B,0x6F,0x44,0x40,0x00,0x00,0x00,0x00,0x2A,0x0F,0x05,0x12,0x71,0x6E,
										 0x73,0x75,0x74,0x76,0x70,0x6F,0x72,0x75,0x71,0x74,0x76,0x73,0x78,0x74,0x6D,0x75,0x69,0x5C,0x6F,0x7C,
										 0x7E,0x7B,0x64,0x73,0x68,0x00,0x00,0x00,0x00,0x00,0x00,0x2A,0x12,0x08,0x16,0x70,0x6F,0x71,0x76,0x75,
										 0x75,0x72,0x6F,0x74,0x72,0x6F,0x73,0x74,0x70,0x77,0x73,0x6B,0x75,0x62,0x4B,0x69,0x73,0x70,0x76,0x3E,0x5B,0x5A);
		}
		else if (return_size == 105)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 return_size,
										 0x00,0x31,0x01,0x01,0x9E,0x41,0x33,0x54,0x53,0x31,0x53,0x30,0x39,0x30,0x31,0x38,0x42,0x42,0x32,0x32,
										 0x35,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x15,0xAE,0xAE,
										 0xAD,0x7B,0x7A,0x7C,0x7B,0x79,0x7B,0x77,0x76,0x79,0x77,0x73,0x77,0x77,0x75,0x79,0x76,0x73,0x78,0x73,
										 0x72,0x76,0x82,0x83,0x7F,0x67,0x7B,0x6F,0x44,0x40,0x00,0x00,0x00,0x00,0x2A,0x0F,0x05,0x12,0x71,0x6E,
										 0x73,0x75,0x74,0x76,0x70,0x6F,0x72,0x75,0x71,0x74,0x76,0x73,0x78,0x74,0x6D,0x75,0x69,0x5C,0x6F,0x7C,0x7E,0x7B,0x64,0x73,0x68);
		}
		else if (return_size == 70)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 return_size,
										 0x00,0x31,0x01,0x01,0x9E,0x41,0x33,0x54,0x53,0x31,0x53,0x30,0x39,0x30,0x31,0x38,0x42,0x42,0x32,0x32,
										 0x35,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x15,0xAE,0xAE,
										 0xAD,0x7B,0x7A,0x7C,0x7B,0x79,0x7B,0x77,0x76,0x79,0x77,0x73,0x77,0x77,0x75,0x79,0x76,0x73,0x78,0x73,
										 0x72,0x76,0x82,0x83,0x7F,0x67,0x7B,0x6F,0x44,0x40);
		}
		else if (return_size == 21)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 return_size,
										 0x00,0x31,0x01,0x01,0x9E,0x41,0x33,0x54,0x53,0x31,0x53,0x30,0x39,0x30,0x31,0x38,0x42,0x42,0x32,0x32,0x35);
		}
		else if (return_size == 10)
		{
			if ((c9_read_flag&0xF0) ==0)
			{
				if ((c9_read_flag&0x0F) ==0)
				{
					c9_read_flag |=0x01;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x31,0x01,0x01,0x9E,0x41,0x33,0x54,0x53,0x31,0x53);
												 10, 0x40,0x01,0x01,0xA0,0x41,0x33,0x54,0x5A,0x31,0x53); 

				}
				else
				{
					c9_read_flag &=0xF0;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x30,0x39,0x30,0x31,0x38,0x42,0x42,0x32,0x32,0x35);
					                             10, 0x30,0x31,0x43,0x44,0x4E,0x42,0x45,0x30,0x36,0x39);  

				}
			}
			else if ((c9_read_flag&0xF0) ==0x10) // C8
			{
				if ((c9_read_flag&0x0F) ==0)
				{
					c9_read_flag &=0xF0;
					c9_read_flag |=0x01;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x15,0xAE,0xAE,0xAD,0x7B,0x7A,0x7C,0x7B,0x79,0x7B);
					                             10, 0x15,0xAE,0xAF,0xAE,0x7B,0x7A,0x7B,0x7B,0x7A,0x7C); 

				}
				else if ((c9_read_flag&0x0F) ==1)
				{
					c9_read_flag &=0xF0;
					c9_read_flag |=0x02;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x77,0x76,0x79,0x77,0x73,0x77,0x77,0x75,0x79,0x76);
					                             10, 0x77,0x75,0x79,0x76,0x73,0x77,0x78,0x75,0x7A,0x77); 

				}
				else
				{
					c9_read_flag &=0xF0;
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_LONG_RESPONSE,
												 DSI_VC_0,
												 //10, 0x73,0x78,0x73,0x72,0x76,0x82,0x83,0x7F,0x67,0x7B);
					                             10, 0x73,0x77,0x6D,0x6B,0x73,0x82,0x85,0x81,0x6A,0x78);

				}
			}
			else // if ((c9_read_flag&0xF0) ==0x20)  //B3
			{
				if ((c9_read_flag&0x0F) ==0)
				{
					c9_read_flag |=0x01;
					if (c9_read_flag2 >2)
						c9_read_flag2 =0;
					
					if (c9_read_flag2 >=2)
					{
						hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
													 DSI_ACK_DT_DSC_LONG_RESPONSE,
													 DSI_VC_0,
													 //10, 0x2A,0x12,0x08,0x16,0x70,0x6F,0x71,0x76,0x75,0x75);
						                             10, 0x2A,0x1C,0x11,0x24,0x6E,0x6B,0x6F,0x76,0x76,0x77);

					}
					else
					{
						hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
													 DSI_ACK_DT_DSC_LONG_RESPONSE,
													 DSI_VC_0,
													 //10, 0x2A,0x0F,0x05,0x12,0x71,0x6E,0x73,0x75,0x74,0x76);
						                             10, 0x2A,0x16,0x0B,0x1E,0x70,0x6E,0x72,0x78,0x78,0x78);

					}
					c9_read_flag2++;
				}
				else if ((c9_read_flag&0x0F) ==1)
				{
					c9_read_flag |=0x02;
					if (c9_read_flag2 >2)
					{
						hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
													 DSI_ACK_DT_DSC_LONG_RESPONSE,
													 DSI_VC_0,
													 //10, 0x72,0x6F,0x74,0x72,0x6F,0x73,0x74,0x70,0x77,0x73);
						                             10, 0x71,0x6F,0x71,0x73,0x71,0x76,0x75,0x71,0x77,0x74);

					}
					else
					{
						hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
													 DSI_ACK_DT_DSC_LONG_RESPONSE,
													 DSI_VC_0,
													 //10, 0x70,0x6F,0x72,0x75,0x71,0x74,0x76,0x73,0x78,0x74);
						                             10, 0x6F,0x6D,0x71,0x74,0x72,0x75,0x77,0x73,0x78,0x75);
					}
				}
				else
				{
					c9_read_flag &=0xF0;
					if (c9_read_flag2 >2)
					{
						hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
													 DSI_ACK_DT_DSC_LONG_RESPONSE,
													 DSI_VC_0,
													 //10, 0x6B,0x75,0x62,0x4B,0x69,0x73,0x70,0x76,0x3E,0x5B);
						                             10, 0x6D,0x76,0x50,0x3C,0x5B,0x73,0x6C,0x74,0x40,0x52);

					}
					else
					{
						hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
													 DSI_ACK_DT_DSC_LONG_RESPONSE,
													 DSI_VC_0,
													 //10, 0x6D,0x75,0x69,0x5C,0x6F,0x7C,0x7E,0x7B,0x64,0x73);
						                             10, 0x70,0x77,0x5A,0x52,0x63,0x7A,0x79,0x7A,0x5D,0x6F);
					}
				}
			}
			
		}
		else if (return_size == 4)
		{
			c8_read_flag =0x10;  // C8C9(size=4)棬־0x10
			
			c9_read_flag &=0xF0;
			if ((c9_read_flag&0xF0) ==0x10)
			{
				hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
											 DSI_ACK_DT_DSC_LONG_RESPONSE,
											 DSI_VC_0,
											 //4, 0x6F,0x44,0x40,0x00);
				                             4, 0x6D,0x44,0x40,0x00);

			}
			else
			{
				hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
											 DSI_ACK_DT_DSC_LONG_RESPONSE,
											 DSI_VC_0,
											 //4, 0x6F,0x44,0x40,0x00);
											 4, 0x6D,0x44,0x40,0x00);
			}
		}
		else if (return_size == 1)
		{
			c8_read_flag =0x20;  // C8C9(size=1)棬־0x20
			
			if ((c9_read_flag&0xF0) ==0x20)
			{
				if (c9_read_flag2 >2)
				{
					if (c9_read_flag3)
						c9_read_flag3 =0;
					else
						c9_read_flag3 =1;

					if (c9_read_flag3)	
						c8_read_flag =0x10;  // C8Ϊ0x10
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
												 DSI_VC_0,
												 1, 0x58);  //1, 0x5A);
				}
				else
				{
					c9_read_flag =0x10;  // C9Ϊ0x10
					hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
												 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
												 DSI_VC_0,
												 1, 0x69);  //1, 0x68);
				}
			}
			else
			{
				hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
											 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
											 DSI_VC_0,
											 1, 0x51);
			}
		}
		else
		{
			TAU_LOGD("r[%x] [%d] err", dcs_cmd, return_size);
		}
//		c9_read_flag =0x00|(c9_read_flag&0x0F);  // C9C9棬־0x20
	}
	else if (dcs_cmd == 0xB3)
	{
		if (return_size == 39)
		{
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 return_size,
										 0x21,0x00,0x50,0x00,0x28,0x2A,0x64,0x58,0x69,0x77,0x77,0x77,0x7B,0x7A,0x7B,0x7A,0x7A,0x7A,0x7F,0x7E,
										 0x7D,0x7D,0x7E,0x7E,0x7D,0x7E,0x7F,0x7F,0x7A,0x80,0x7B,0x76,0x7A,0x54,0x6C,0x61,0x00,0x00,0x00);
		}
		else if (return_size == 10)
		{
			if (b3_read_flag ==0)
			{
				b3_read_flag =1;
				hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
											 DSI_ACK_DT_DSC_LONG_RESPONSE,
											 DSI_VC_0,
											 //10, 0x2A,0x64,0x58,0x69,0x77,0x77,0x77,0x7B,0x7A,0x7B);
				                             10, 0x2A,0x6A,0x5F,0x73,0x76,0x74,0x77,0x7D,0x7E,0x7D);

			}
			else if (b3_read_flag ==1)
			{
				b3_read_flag =2;
				hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
											 DSI_ACK_DT_DSC_LONG_RESPONSE,
											 DSI_VC_0,
											 //10, 0x7A,0x7A,0x7A,0x7F,0x7E,0x7D,0x7D,0x7E,0x7E,0x7D);
				                             10, 0x7A,0x7B,0x7A,0x7C,0x7D,0x7C,0x80,0x80,0x7F,0x7F);

			}
			else //if (b3_read_flag ==2)
			{
				b3_read_flag =0;
				hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
											 DSI_ACK_DT_DSC_LONG_RESPONSE,
											 DSI_VC_0,
											 //10, 0x7E,0x7F,0x7F,0x7A,0x80,0x7B,0x76,0x7A,0x54,0x6C);
				                             10, 0x7E,0x80,0x6F,0x6C,0x72,0x7E,0x7A,0x7C,0x60,0x70);

			}
			
		}
		else if (return_size == 4)
		{
			c9_read_flag =0x20;  // C9B3棬־0x20
			c8_read_flag =0x10;  // C8B3棬־0x10
			
			b3_read_flag =0;
			hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
										 DSI_ACK_DT_DSC_LONG_RESPONSE,
										 DSI_VC_0,
										 //4, 0x61,0x00,0x00,0x00);
			                             4, 0x6B,0x00,0x00,0x00);

		}
		else
		{
			TAU_LOGD("r[%x] [%d] err", dcs_cmd, return_size);
		}
	}
	else
	{
		hal_dsi_rx_ctrl_send_ack_cmd(g_rx_ctrl_handle,
									 DSI_ACK_DT_DSC_SHORT_RESPONSE_1B,
									 DSI_VC_0,
									 1, 0);
		TAU_LOGD("r[%x] [%d] err!!!!!!", dcs_cmd, return_size);
	}
	//TAU_LOGD("r %x\n",dcs_cmd);
	return true;
#endif // USE_FOR_SUMSUNG_S20
		
}

bool ap_tear_flag = true;
/* PPS update callback ڷֱлcase */
static bool pps_update_handle(uint8_t *pps, uint8_t size, uint32_t pic_width, uint32_t pic_height)
{
    //hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);
    if (pic_width != g_rx_ctrl_handle->base_info.src_w || pic_height != g_rx_ctrl_handle->base_info.src_h)
    {
        /* PPS Update ҷֱʷ仯 */
        hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
        g_rx_ctrl_handle->base_info.src_w = pic_width;
        g_rx_ctrl_handle->base_info.src_h = pic_height;
        /* עⲿֻPPSǰ Compression Mode Command */
        g_rx_ctrl_handle->compress_en = true;   //hal_dsi_rx_ctrl_get_compressen_en(g_rx_ctrl_handle);
//		g_rx_ctrl_handle->compress_en = hal_dsi_rx_ctrl_get_compressen_en(g_rx_ctrl_handle);
		if(pic_width > 720)
		{
	        g_tx_ctrl_handle->base_info.src_w = pic_width;
	        g_tx_ctrl_handle->base_info.src_h = pic_height;
		}
        hal_dsi_rx_ctrl_toggle_resolution(g_rx_ctrl_handle);
        //*((uint32_t *)(0x40002B04)) = 1;
        if(ap_tear_flag){
            hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
        }else{
            hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
        }
    }
    return true;
}

static bool ap_update_frame_rate(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	static uint8_t frame_rate = 100;      //ÿλʱĻʾ60hzǶȡframe_rateȴ
	if (frame_rate != dcs_packet->packet_param[0])
	{
		frame_rate = dcs_packet->packet_param[0];	
		if (frame_rate == 0x20)    //120hz
		{
			hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, SYNC_LIN_NUMBER, TE_SOFT_120HZ_MODE);
			TAU_LOGD("120HZ");
		}
		else 
		{
			hal_dsi_rx_ctrl_set_tear_mode_ex(g_rx_ctrl_handle, SYNC_LIN_NUMBER, TE_HW_MODE);
			TAU_LOGD("60HZ");   //00 60HZ
		}
//		TAU_LOGD("frame_rate:[%02X], %d", dcs_packet->packet_param[0], dcs_packet->param_length);
	}		
	return true;
}

bool g_enter_display_off = false;
bool g_enter_display_ON = false;

static bool ap_set_display_on(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
//    if(g_enter_display_off == true)
{
    //    Gpio_swire_output(2,38);
        g_enter_display_ON = true;
    }
   // hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, 0, 0x1F);
	//	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 2, 0x29);
   // TAU_LOGD("disp on");
    return true;
}

static bool ap_set_display_off(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    Gpio_swire_output(0, 0);

    TAU_LOGD("disp off");
    g_enter_display_off = true;
    hal_dsi_tx_ctrl_write_cmd(0x05, 0, 2, 0x28);
//  hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_LOW);
    return true;
}

static bool ap_set_enter_sleep_mode(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    hal_dsi_tx_ctrl_write_cmd(0x05, 0, 2, 0x10);
#if ENABLE_TP_WAKE_UP
	g_need_enter_sleep_mode = true;
#endif
    g_exit_sleep_mode = false;
  //  TAU_LOGD("enter sleep mode");
    soft_disable_mipi_timer_init();
    return true;
}

static bool ap_set_exit_sleep_mode(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    TAU_LOGD("exit sleep mode");
    /* AVDD ϵ, ڽϢPPS */
    //hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);  //leo
    g_exit_sleep_mode = true;
	
    return true;
}

/*****************************************************************************
*GPIOswire
*flag:  =0, SWIRE=0;  =1,SWIREź; =2, øٷSWIREź
*num: 
*עFLAG=1ʱGPIOʼ!!!!!!
*****************************************************************************/
#define GPIO_SWIRE_PAD IO_PAD_AP_SWIRE      //S20Pʹô
//#define GPIO_SWIRE_PAD IO_PAD_ADCIN       //S20Uʹô
void Gpio_swire_output(uint8_t flag, uint8_t num)
{
	uint8_t ii;

	if (flag)
	{
		if (flag ==2)
		{
			//hal_gpio_init_output(GPIO_SWIRE_PAD, IO_LVL_HIGH);	  
			hal_gpio_set_output_data(GPIO_SWIRE_PAD, IO_LVL_HIGH);	
			hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_HIGH);
			//delayMs(4);   //2
			delayUs(807);
		}
		for (ii =0; ii< num; ii++)
		{
			hal_gpio_set_output_data(GPIO_SWIRE_PAD, IO_LVL_LOW);
			hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_LOW);
			delayUs(9);
			hal_gpio_set_output_data(GPIO_SWIRE_PAD, IO_LVL_HIGH);
			hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_HIGH);
			delayUs(9);
		}
	}
	else
	{
		hal_gpio_init_output(GPIO_SWIRE_PAD, IO_LVL_LOW);	 
		hal_gpio_init_output(IO_PAD_ADCIN, IO_LVL_LOW);			
	}
}

#ifdef ADD_PWM_OUTPUT_FOR_BL
/*****************************************************************************
* @brief  pwmԿƱ
* @param  init:     ǷΪʼһαѡʼ
* @param  polarity: ԣfalse:ȸߺͣtrue:ȵͺ
* @param  duty_ratio: ռձ(0-100)
* @param  frequency: ƵʣλHZ
* @retval null
*****************************************************************************/
static void test_pwm_out_adjust(bool init, bool polarity, uint8_t duty_ratio, uint32_t frequency)
{

    pwm_out_ctrl_e ctl0 = PWMO_CTRL_HIGH;
    pwm_out_ctrl_e ctl1 = PWMO_CTRL_LOW;
    if (polarity)
    {
        ctl0 = PWMO_CTRL_LOW;
        ctl1 = PWMO_CTRL_HIGH;
    }
    uint32_t period = 1000000 / frequency; //λus
    uint32_t thr0 = 0;
    uint32_t thr1 = (period * duty_ratio / 100);

    if (duty_ratio == 100)
    {
        ctl1 = ctl0;
        thr1 = period / 2;
    }
    if (init)
    {
        hal_pwm_out_init();
        hal_pwm_out_config_all(ctl0, ctl1, thr0, thr1, period);
    }
    else
    {
        hal_pwm_out_sync_all(ctl0, ctl1, thr0, thr1, period);
    }
}

void PWM_OUTPUT_TEST(void)
{
    test_pwm_out_adjust(true, true, 30, 20000);
    delayMs(2);
    test_pwm_out_adjust(false, false, 40, 10000);
}

#define PWM_PERIOD     1000   //PWM.λUS
#define PWM_MIN		 8		//Сֵɵ
static void PWM_init(void)
{
	// 1ms ڳʼ͵ƽ1000
	hal_pwm_out_init();
	hal_pwm_out_config_all(PWMO_CTRL_LOW, PWMO_CTRL_HIGH, 0, PWM_PERIOD, PWM_PERIOD);
}

static uint16_t read_bl_data =0;
static uint16_t read_bl_data_bak =0;
void PWM_Task(void)
{
uint16_t pwm_h;

#ifdef USE_FOR_SUMSUNG_S20
// s20: read_bl_data = 1~FD

	if(Flag_blacklight_EN)
	{
		read_bl_data_bak =0;
		hal_pwm_out_sync_thr(0, PWM_PERIOD+1);
		//printf("Flag_blacklight_EN!!!! read_bl_data[%4x] \n", read_bl_data);
		return;
	}

	if (g_need_enter_sleep_mode)
	{
		//ΪϨʱ
		read_bl_data_bak =0;
		hal_pwm_out_sync_thr(0, PWM_PERIOD-PWM_MIN); //ΪС
//		printf("tp_sleep_in!!!! read_bl_data[%4x] \n", read_bl_data);
	//	return;
	}
	
	if(read_bl_data !=read_bl_data_bak)
	{
		pwm_h = PWM_PERIOD*read_bl_data/0xFF;
	#if 1//Բ
		if (pwm_h >700)
			pwm_h = 300+(pwm_h-700)*7/3;
		else
			pwm_h = 1+(pwm_h-1)*3/7;
	#endif
		if(pwm_h <PWM_MIN)
			pwm_h =PWM_MIN;
	
		//printf("ok!!!! read_bl_data[%4x],pwm_h[%d] \n", read_bl_data, pwm_h);

		if(pwm_h <PWM_PERIOD)
			pwm_h = PWM_PERIOD-pwm_h;
		else
			pwm_h = 1;
		hal_pwm_out_sync_thr(0, pwm_h);
		read_bl_data_bak =read_bl_data;
	}
#endif

}
#endif

/* B1ص      g_cus_rx_dcs_execute_table Ϊ첽ִУCAͬ*/

static uint8_t bl_adj_flag =0;   
uint16_t value_reg_b1 =0;
uint32_t value_reg_ca =0;
//static uint32_t value_reg_b5 =0;
static uint32_t value_reg_df =0;
static uint8_t value_blue =0;
static uint8_t blue_flag =0;
#if 1 //
#define BLUE_MAX			0xF0	//ֵ
#define BLUE_MIN			0x86	//Сֵ
#define BLUE_STEP			10		//ȼ-1
#endif

#if 1//def USE_FOR_SUMSUNG_S20
static uint32_t s20_power_on_flag =0;   // >0: Ϊǡʱ
uint32_t value_reg_ca_bak =0;
uint16_t value_reg_b1_bak =0;
//#define USE_BL_ADJ6  //֮ǰS20ⷽʽ
#define USE_BL_ADJ7    //ĹS20ⷽʽ
uint16_t value_reg51 =0;
uint16_t value_reg51_bak =0;
#endif

#if 1 //
static bool ap_set_backlight(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    /* AP  0xC  0xb8d , ʱ0xC,ƽҪһŻ */
    uint16_t temp_u16,temp_min,temp_max;
    uint16_t temp51_min,temp51_max;

	value_reg_b1 = (dcs_packet->packet_param[0] << 8) + dcs_packet->packet_param[1];
//  printf("B1[%4x],CA[%4x] \n", value_reg_b1, value_reg_ca);
//  TAU_LOGD("B1[%x]", value_reg_b1);

#ifdef USE_BL_ADJ7

#if 0//def ADD_PWM_OUTPUT_FOR_BL
	if (value_reg_b1 &0x8000)
	{
		// 60Hz	
		if(value_reg_ca >0x15FE)
		{
			read_bl_data = 0xFF;
		}
		else if(value_reg_ca >=0x1550)
		{
			// value_reg_ca =0x1550Ӧ105(ǵ⼶Ϊ256)
			read_bl_data = 105+(value_reg_ca-0x1550)*150/175;
		}
		else
		{
			//value_reg_b1_bak=0xC65~0x1E4Ӧ1~104
			if (value_reg_b1_bak>0xC65)
				read_bl_data =1;
			else if (value_reg_b1_bak<0x1E4)
				read_bl_data =104;
			else
				read_bl_data = 1+(0xC65-value_reg_b1_bak)*103/2689;
		}
	}	
	else if (value_reg_b1 &0x4000)
	{
		// 120Hz	
		if(value_reg_ca >0x15AD)
		{
			read_bl_data = 0xFF;
		}
		else if(value_reg_ca >=0x150F)
		{
			// value_reg_ca =0x15AD~0x150FӦ256~109(ǵ⼶Ϊ256)
			read_bl_data = 109+(value_reg_ca-0x150F)*146/158;
		}
		else
		{
			//value_reg_b1_bak=0xC54~0x1E4Ӧ1~108
			if (value_reg_b1_bak>0xC54)
				read_bl_data =1;
			else if (value_reg_b1_bak<0x1E4)
				read_bl_data =108;
			else
				read_bl_data = 1+(0xC54-value_reg_b1_bak)*107/2672;
		}
	}	
	else
	{
		value_reg_b1_bak = value_reg_b1;
		if ((value_reg_ca ==0x2A00) &&(value_reg_b1 >0x500))
			s20_power_on_flag =1; 
		else
			s20_power_on_flag =0;
	}


#else
	if (dcs_packet->param_length ==1)
	{
		if (bl_adj_flag)
		{
		// ֻ120Hzģʽ¡CAΪ0	
			if(value_reg_b1_bak <=0x222)
			{
				switch(value_reg_ca)
				{
					case 0:
					case 1:
						value_reg51 = 255;  //255
					break;
					
					case 2:
						value_reg51 = 252;
					break;
					
					case 3:
						value_reg51 = 249;
					break;
					
					case 4:
						value_reg51 = 245;
					break;
					
					case 5:
						value_reg51 = 239;
					break;
					
					case 6:
						value_reg51 = 235;
					break;
					
					case 7:
					case 8:
						value_reg51 = 229;
					break;
					
					case 9:
						value_reg51 = 222;
					break;
					
					case 10:
						value_reg51 = 212;
					break;
					
					case 11:
						value_reg51 = 207;
					break;
					
					case 12:
						value_reg51 = 203;
					break;

 					case 13:
						value_reg51 = 200;
					break;
					
					case 14:
						value_reg51 = 198;
					break;
					
					case 15:
						value_reg51 = 195;
					break;
					
					case 16:
						value_reg51 = 189;
					break;

 					case 17:
						value_reg51 = 182;
					break;
					
					case 18:
						value_reg51 = 178;
					break;

 					case 19:
						value_reg51 = 175;
					break;
					
					case 20:
						value_reg51 = 171;
					break;

					default:
 					case 21:
						value_reg51 = 168;
					break;
				}
			}
			else if(value_reg_b1_bak <=0x55B)
			{
				// value_reg_b1_bak =0x55B ~ 0x22BӦ130 ~ 167(ǵ⼶Ϊ256)
				temp_max = 0x55B;
				temp_min = 0x22B;

				temp51_max =167;
				temp51_min =130;
				if(value_reg_b1_bak<=temp_min)
					value_reg51 =temp51_max;
				else if(value_reg_b1_bak>=temp_max)
					value_reg51 =temp51_min;
				else
					value_reg51 = temp51_max - (value_reg_b1_bak-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}
			else if(value_reg_b1_bak ==0x56F)
			{
				if(value_reg_ca <0x27)
				{
					value_reg51 = 122;
				}
				else if(value_reg_ca <0x2D)
				{
					value_reg51 = 116;
				}
				else if(value_reg_ca <0x30)
				{
					value_reg51 = 112;
				}
				else if(value_reg_ca <0x3B)
				{
					value_reg51 = 108;
				}
				else if(value_reg_ca <0x40)
				{
					value_reg51 = 105;
				}
				else if(value_reg_ca <0x50)
				{
					value_reg51 = 103;
				}
				else
				{
					value_reg51 = 101;
				}
			}			
			else if(value_reg_b1_bak <=0xB3B)
			{
				// value_reg_b1_bak =0xB3B ~ 0x589Ӧ55~ 100(ǵ⼶Ϊ256)
				temp_max = 0xB3B;
				temp_min = 0x589;

				temp51_max =100;
				temp51_min =55;
				if(value_reg_b1_bak<=temp_min)
					value_reg51 =temp51_max;
				else if(value_reg_b1_bak>=temp_max)
					value_reg51 =temp51_min;
				else
					value_reg51 = temp51_max - (value_reg_b1_bak-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}
			else if(value_reg_b1_bak <=0xBF9)
			{
				// value_reg_b1_bak =0xB44 ~ 0xBF9Ӧ54~ 37(ǵ⼶Ϊ256)
				temp_max = 0xBF9;
				temp_min = 0xB44;

				temp51_max =54;
				temp51_min =37;
				if(value_reg_b1_bak<=temp_min)
					value_reg51 =temp51_max;
				else if(value_reg_b1_bak>=temp_max)
					value_reg51 =temp51_min;
				else
					value_reg51 = temp51_max - (value_reg_b1_bak-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}
			else
			{
				// value_reg_b1_bak =0xC0B ~ 0xC71Ӧ36 ~ 1(ǵ⼶Ϊ256)
				temp_max = 0xC71;
				temp_min = 0xC0B;

				temp51_max =36;
				temp51_min =1;
				if(value_reg_b1_bak<=temp_min)
					value_reg51 =temp51_max;
				else if(value_reg_b1_bak>=temp_max)
					value_reg51 =temp51_min;
				else
					value_reg51 = temp51_max - (value_reg_b1_bak-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}
		}
		else if (dcs_packet->packet_param[0] &0x80)
		{
		//Ϊ60Hz		
			if(value_reg_ca >=0x15C0)
			{
			// value_reg51 = 0xC0~ 0xFF
				if(value_reg_ca >=0x15FF)
					value_reg51 = 0xFF;
				else
					value_reg51 = value_reg_ca&0xFF;
			}
			else if(value_reg_ca >0x15B8)
			{
			// value_reg51 = 0x90~ 0xC0
				temp_max = 0x573;
				temp_min = 0x1EE;

				temp51_max =0xC0;
				temp51_min =0x90;
				if(value_reg_b1_bak<=temp_min)
					value_reg51 =temp51_max;
				else if(value_reg_b1_bak>=temp_max)
					value_reg51 =temp51_min;
				else
					value_reg51 = temp51_max - (value_reg_b1_bak-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}
			else if(value_reg_ca >=0x156D)
			{
			// value_reg51 = 0x70~ 0x90
				temp_max = 0x15B8;
				temp_min = 0x156D;
			
				temp51_max =0x90;
				temp51_min =0x70;
				if(value_reg_ca <=temp_min)
					value_reg51 =temp51_min;
				else if(value_reg_ca>=temp_max)
					value_reg51 =temp51_max;
				else
					value_reg51 = temp51_min + (value_reg_ca-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}
			else
			{
			// value_reg51 = 0x10~ 0x70
				temp_max = 0xC77;
				temp_min = 0x587;
			
				temp51_max =0x70;
				temp51_min =1;
				if(value_reg_b1_bak<=temp_min)
					value_reg51 =temp51_max;
				else if(value_reg_b1_bak>=temp_max)
					value_reg51 =temp51_min;
				else
					value_reg51 = temp51_max - (value_reg_b1_bak-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);

			}
		}
		else //if (dcs_packet->packet_param[0] &0x40)
		{
		//Ϊ120Hz		
			if(value_reg_ca >=0x156D)
			{
			// value_reg51 = 0xBE~ 0xFF
				if(value_reg_ca >=0x15AE)
					value_reg51 = 0xFF;
				else
					value_reg51 = (value_reg_ca&0xFF)+0x51;
			}
			else if(value_reg_ca >0x1564)
			{
			// value_reg51 = 0x90~ 0xBE
				temp_max = 0x56F;
				temp_min = 0x1ED;

				temp51_max =0xBE;
				temp51_min =0x90;
				if(value_reg_b1_bak<=temp_min)
					value_reg51 =temp51_max;
				else if(value_reg_b1_bak>=temp_max)
					value_reg51 =temp51_min;
				else
					value_reg51 = temp51_max - (value_reg_b1_bak-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}
			else if(value_reg_ca >=0x1518)
			{
			// value_reg51 = 0x70~ 0x90
				temp_max = 0x1518;
				temp_min = 0x1564;
			
				temp51_max =0x90;
				temp51_min =0x70;
				if(value_reg_ca <=temp_min)
					value_reg51 =temp51_min;
				else if(value_reg_ca>=temp_max)
					value_reg51 =temp51_max;
				else
					value_reg51 = temp51_min + (value_reg_ca-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}
			else
			{
			// value_reg51 = 0x01~ 0x70
				temp_max = 0xC71;
				temp_min = 0x5A2;
			
				temp51_max =0x70;
				temp51_min =0x01;
				if(value_reg_b1_bak<=temp_min)
					value_reg51 =temp51_max;
				else if(value_reg_b1_bak>=temp_max)
					value_reg51 =temp51_min;
				else
					value_reg51 = temp51_max - (value_reg_b1_bak-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);

			}
		}
		
		if (value_reg51 != value_reg51_bak)
		{
		#if 0// 1: ƽһ
			if (value_reg51 <0x41)
			{
				temp_max = 0x40;
				temp_min = 1;
			
				temp51_max =0x100;
				temp51_min =0x10;
				
				temp_u16 = temp51_min + (value_reg51-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}
			else if (value_reg51 <0x81)
			{
				temp_max = 0x80;
				temp_min = 41;
			
				temp51_max =0x400;
				temp51_min =0x101;
				
				temp_u16 = temp51_min + (value_reg51-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}
			else
			{
				temp_max = 0xFF;
				temp_min = 0x81;
			
				temp51_max =0xDBB;
				temp51_min =0x401;
				
				temp_u16 = temp51_min + (value_reg51-temp_min)*(temp51_max-temp51_min)/(temp_max-temp_min);
			}

		#else
		 temp_u16=(value_reg51-0x01)*15+0xB0;
		//	temp_u16 = value_reg51*0xFFF/0xFF;
		#endif
			//temp_u16 = value_reg51;
			
			//
	//		if (temp_u16 <0x3F)
	//			temp_u16 = 0X3F;
	      if(temp_u16 == 0x1be)
          {
                temp_u16 = 0x1cd;
          }
		//Ϣѱ
		if(phone_power_on == true||g_enter_display_ON == true)
		{
			hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, temp_u16>>8, temp_u16&0xFF);
		}
   // if(g_enter_display_ON == false)	
		else	{
	
	    hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, 0, 0x01);  //0x001F
    }	
   phone_power_on = false;
			//hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, 0, 0xF4);
			value_reg51_bak = value_reg51;
			//  printf("B1[%4x],CA[%4x] \n", value_reg_b1, value_reg_ca);
		//	TAU_LOGD("B1[%4x],CA[%4x],51[%02x], value_reg51[%02x]", value_reg_b1, value_reg_ca, value_reg51 , temp_u16);
		}
	}

#endif

#endif //  // USE_BL_ADJ7

    return true;
}
#endif

static bool ap_get_reg_ca(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	bl_adj_flag =0;
    value_reg_ca = (dcs_packet->packet_param[0] << 8)+ dcs_packet->packet_param[1];
	if (value_reg_ca ==0)
	{
		bl_adj_flag =1;
		value_reg_ca = dcs_packet->packet_param[5];
	}
	value_reg_b1_bak = value_reg_b1;
    return true;
}

#if 0
static bool ap_get_reg_b5(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    value_reg_b5 = (dcs_packet->packet_param[3] << 8) + dcs_packet->packet_param[2];
    TAU_LOGD("CA[%4x],B1[%4x],B5[%4x]", value_reg_ca,value_reg_b1,value_reg_b5);

    return true;
}
#endif

#ifdef ADD_PANEL_DISPLAY_MODE
uint8_t panel_mode =1; 			// DFĴ100:ۿ,01:۹,11:3(ӰԺ/Ƭ/.Ŀǰû)
uint16_t panel_r,panel_g,panel_b; // ¼RGBֵ

#ifdef USE_FOR_SUMSUNG_S9PLUS
#define RATIO_VALUE 2   				 //Żϵ
#else
#define RATIO_VALUE 2   				 //Żϵ
#endif

#endif


static bool ap_get_reg_df(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	ccm_coef_t ccm;
	ccm.coef_c00 = 255;
	ccm.coef_c01 = 0;
	ccm.coef_c02 = 0;
	ccm.coef_c10 = 0;
	ccm.coef_c11 = 255;
	ccm.coef_c12 = 0;
	ccm.coef_c20 = 0;
	ccm.coef_c21 = 0;
	ccm.coef_c22 = 255;
	
#ifdef ADD_PANEL_DISPLAY_MODE
	value_reg_df = (dcs_packet->packet_param[35] << 8) + dcs_packet->packet_param[33];
	panel_mode = dcs_packet->packet_param[0];
	panel_r =dcs_packet->packet_param[49];
	panel_g =dcs_packet->packet_param[51];
	panel_b =dcs_packet->packet_param[53];
//	TAU_LOGD("value_reg_df[%4x],panel_mode[%4x],panel_r[%4x],panel_g[%4x],panel_b[%4x]", value_reg_df,panel_mode,panel_r,panel_g,panel_b);

	if (panel_mode ==00)
	{
	  	//ģʽ
		
	#ifdef USE_FOR_S10_BLUE_MODE
		//panel_r =256-RATIO_VALUE*(0xFF-panel_r);
		//panel_g =256-RATIO_VALUE*(0xFF-panel_g);
		//panel_b =256-RATIO_VALUE*(0xFF-panel_b);
//		hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,panel_r,panel_g,panel_b);
		ccm.coef_c00 = panel_r;
		ccm.coef_c11 = panel_g;
		ccm.coef_c22 = panel_b;
		hal_dsi_tx_ctrl_set_ccm(ccm);

	#else
	
		value_reg_df =value_reg_df&0xFF;
		switch(value_reg_df)
		{
			case 0xC1:
			case 0xC3:
				value_blue = BLUE_MIN;
			break;
			
			case 0xCF:
			case 0xD0:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)/BLUE_STEP;
			break;
			
			case 0xD8:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*2/BLUE_STEP;
			break;
			
			case 0xDE:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*3/BLUE_STEP;
			break;
			
			case 0xE4:
			case 0xE5:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*4/BLUE_STEP;
			break;
			
			case 0xE9:
			case 0xEA:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*5/BLUE_STEP;
			break;
			
			case 0xED:
			case 0xEE:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*6/BLUE_STEP;
			break;
			
			case 0xF1:
			case 0xF2:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*7/BLUE_STEP;
			break;
			
			case 0xF4:
			case 0xF5:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*8/BLUE_STEP;
			break;
			
			case 0xF7:
			case 0xF8:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*9/BLUE_STEP;
			break;
			
			case 0xFA: 
				value_blue = BLUE_MAX; 
			break; 

			default: 
			case 0xFF: 
				value_blue = 0; 
			break; 
			 
		}
		hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,256,256,256); 
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue); 
		
	#endif	

	}
	else
	{
	#ifndef USE_FOR_S10_BLUE_MODE 
		value_blue =0; 
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);  //ģʽs8+/s9+ 
	#endif 

		//һ㣬ЧԡҪݿͻҪϸ 
		panel_r =208-RATIO_VALUE*(0xFF-panel_r);  //230  
		panel_g =218-RATIO_VALUE*(0xFF-panel_g);  //235  
		panel_b =218-RATIO_VALUE*(0xFF-panel_b);  //235  
//		hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,panel_r,panel_g,panel_b); 
		
		ccm.coef_c00 = panel_r; 
		ccm.coef_c11 = panel_g; 
		ccm.coef_c22 = panel_b; 
		if((panel_r == 256)&&(panel_g == 256)&&(panel_b == 256)) 
		{
			blue_change_ccm(); 
		}
		else 
			hal_dsi_tx_ctrl_set_ccm(ccm); 
	}
	
	#ifndef USE_FOR_S10_BLUE_MODE 
	if (blue_flag==0) 
	{
		blue_flag =1; 
		delayMs(20); 
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue); 
	}
	#endif

#else
    value_reg_df = (dcs_packet->packet_param[35] << 8) + dcs_packet->packet_param[33];

	value_reg_df =value_reg_df&0xFF;
	switch(value_reg_df)
	{
		case 0xC1:
		case 0xC3:
			value_blue = BLUE_MIN;
		break;
		
		case 0xCF:
		case 0xD0:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)/BLUE_STEP;
		break;
		
		case 0xD8:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*2/BLUE_STEP;
		break;
		
		case 0xDE:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*3/BLUE_STEP;
		break;
		
		case 0xE4:
		case 0xE5:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*4/BLUE_STEP;
		break;
		
		case 0xE9:
		case 0xEA:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*5/BLUE_STEP;
		break;
		
		case 0xED:
		case 0xEE:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*6/BLUE_STEP;
		break;
		
		case 0xF1:
		case 0xF2:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*7/BLUE_STEP;
		break;
		
		case 0xF4:
		case 0xF5:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*8/BLUE_STEP;
		break;
		
		case 0xF7:
		case 0xF8:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*9/BLUE_STEP;
		break;
		
		case 0xFA:
			value_blue = BLUE_MAX;
		break;

		default:
		case 0xFF:
			value_blue = 0;
		break;
		
	}
	
	TAU_LOGD("df[%4x]", value_reg_df);
	hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	if (blue_flag==0)
	{
		blue_flag =1;
		delayMs(20);
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	}
#endif

    return true;
}


#if 0
static bool ap_get_reg_df(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
	ccm_coef_t ccm;
	ccm.coef_c00 = 255;
	ccm.coef_c01 = 0;
	ccm.coef_c02 = 0;
	ccm.coef_c10 = 0;
	ccm.coef_c11 = 255;
	ccm.coef_c12 = 0;
	ccm.coef_c20 = 0;
	ccm.coef_c21 = 0;
	ccm.coef_c22 = 255;
	
#ifdef ADD_PANEL_DISPLAY_MODE
	value_reg_df = (dcs_packet->packet_param[35] << 8) + dcs_packet->packet_param[33];
	panel_mode = dcs_packet->packet_param[0];
	panel_r =dcs_packet->packet_param[49];
	panel_g =dcs_packet->packet_param[51];
	panel_b =dcs_packet->packet_param[53];
//	TAU_LOGD("value_reg_df[%4x],panel_mode[%4x],panel_r[%4x],panel_g[%4x],panel_b[%4x]", value_reg_df,panel_mode,panel_r,panel_g,panel_b);

	if (panel_mode ==00)
	{
	  	//ģʽ
		
	#ifdef USE_FOR_S10_BLUE_MODE
		//panel_r =256-RATIO_VALUE*(0xFF-panel_r);
		//panel_g =256-RATIO_VALUE*(0xFF-panel_g);
		//panel_b =256-RATIO_VALUE*(0xFF-panel_b);
//		hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,panel_r,panel_g,panel_b);
		ccm.coef_c00 = panel_r;
		ccm.coef_c11 = panel_g;
		ccm.coef_c22 = panel_b;
		hal_dsi_tx_ctrl_set_ccm(ccm);

	#else
	
		value_reg_df =value_reg_df&0xFF;
		switch(value_reg_df)
		{
			case 0xC1:
			case 0xC3:
				value_blue = BLUE_MIN;
			break;
			
			case 0xCF:
			case 0xD0:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)/BLUE_STEP;
			break;
			
			case 0xD8:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*2/BLUE_STEP;
			break;
			
			case 0xDE:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*3/BLUE_STEP;
			break;
			
			case 0xE4:
			case 0xE5:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*4/BLUE_STEP;
			break;
			
			case 0xE9:
			case 0xEA:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*5/BLUE_STEP;
			break;
			
			case 0xED:
			case 0xEE:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*6/BLUE_STEP;
			break;
			
			case 0xF1:
			case 0xF2:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*7/BLUE_STEP;
			break;
			
			case 0xF4:
			case 0xF5:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*8/BLUE_STEP;
			break;
			
			case 0xF7:
			case 0xF8:
				value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*9/BLUE_STEP;
			break;
			
			case 0xFA:
				value_blue = BLUE_MAX;
			break;

			default:
			case 0xFF:
				value_blue = 0;
			break;
			
		}
		hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,256,256,256);
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
		
	#endif	

	}
	else
	{
	#ifndef USE_FOR_S10_BLUE_MODE
		value_blue =0;
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);  //ģʽs8+/s9+
	#endif

		//һ㣬ЧԡҪݿͻҪϸ
		panel_r =256-RATIO_VALUE*(0xFF-panel_r);
		panel_g =256-RATIO_VALUE*(0xFF-panel_g);
		panel_b =256-RATIO_VALUE*(0xFF-panel_b);
//		hal_dsi_rx_ctrl_set_cus_pq_gain(g_rx_ctrl_handle,panel_r,panel_g,panel_b);
		
		ccm.coef_c00 = panel_r;
		ccm.coef_c11 = panel_g;
		ccm.coef_c22 = panel_b;
		hal_dsi_tx_ctrl_set_ccm(ccm);
	}
	
	#ifndef USE_FOR_S10_BLUE_MODE
	if (blue_flag==0)
	{
		blue_flag =1;
		delayMs(20);
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	}
	#endif

#else
    value_reg_df = (dcs_packet->packet_param[35] << 8) + dcs_packet->packet_param[33];

	value_reg_df =value_reg_df&0xFF;
	switch(value_reg_df)
	{
		case 0xC1:
		case 0xC3:
			value_blue = BLUE_MIN;
		break;
		
		case 0xCF:
		case 0xD0:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)/BLUE_STEP;
		break;
		
		case 0xD8:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*2/BLUE_STEP;
		break;
		
		case 0xDE:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*3/BLUE_STEP;
		break;
		
		case 0xE4:
		case 0xE5:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*4/BLUE_STEP;
		break;
		
		case 0xE9:
		case 0xEA:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*5/BLUE_STEP;
		break;
		
		case 0xED:
		case 0xEE:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*6/BLUE_STEP;
		break;
		
		case 0xF1:
		case 0xF2:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*7/BLUE_STEP;
		break;
		
		case 0xF4:
		case 0xF5:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*8/BLUE_STEP;
		break;
		
		case 0xF7:
		case 0xF8:
			value_blue = BLUE_MIN+(BLUE_MAX-BLUE_MIN)*9/BLUE_STEP;
		break;
		
		case 0xFA:
			value_blue = BLUE_MAX;
		break;

		default:
		case 0xFF:
			value_blue = 0;
		break;
		
	}
	
	TAU_LOGD("df[%4x]", value_reg_df);
	hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	if (blue_flag==0)
	{
		blue_flag =1;
		delayMs(20);
		hal_dsi_tx_ctrl_write_cmd(0x15, 0, 2, 0x84, value_blue);
	}
#endif

    return true;
}
#endif


static bool ap_set_tear_on(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
    ap_tear_flag = true;
//    printf("tear on\n");
    return true;
}

/* ƻDCS command  */
static const hal_dcs_execute_entry_t g_cus_rx_dcs_execute_table[] =
{
    {DCS_SET_DISPLAY_ON, ap_set_display_on, true},
    {DCS_SET_DISPLAY_OFF, ap_set_display_off, true},
	{0xDF, ap_get_reg_df, false},  //
	{0xCA, ap_get_reg_ca, false},  // ⡣ҪB1ܵ
	{0xB1, ap_set_backlight, false},
	{0x60, ap_update_frame_rate, true},
//	{0x35, ap_set_tear_on, true},
    {DCS_ENTER_SLEEP_MODE, ap_set_enter_sleep_mode, true},
    {DCS_EXIT_SLEEP_MODE, ap_set_exit_sleep_mode, true},
#if ADD_TP_CALIBRATION
//  TP calibration
	{0x04, ap_set_tp_calibration_04, true},
#endif    
	{0, NULL, false}                        //{0,NULL,false} һ̶ԱΪtableβжϱ׼
};

static void tx_panel_reset(void)
{
#ifdef USE_WL518_INTERNAL_FLASH	
		hal_system_share_flash_mode(true);
#endif	

#if USE_FIRST_CODE
    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_HIGH);
    delayMs(10);                //10ms
    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_LOW);
    delayMs(10);                //10ms
    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_HIGH);
    delayMs(10);
#else
	//20221103 ڶģʱ򣬰εоҪ
	hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_HIGH);
    delayMs(50);                //10ms
    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_LOW);
    delayMs(50);                //10ms
    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_HIGH);
    delayMs(50);
#endif
}


#if PANEL_INIT_CODE_ARRAY
static void send_panel_init_code(uint32_t size, uint8_t * data)
{
	uint32_t data_offeset = 0;
	uint8_t data_type;
	uint8_t vc;
	uint8_t data_size;
	uint8_t * p_data;

	while(data_offeset < size)
	{
		data_type = data[data_offeset];
		vc = data[data_offeset + 1];
		data_size = data[data_offeset + 2];
		p_data = &data[data_offeset + 3];
		hal_dsi_tx_ctrl_write_array_cmd(data_type, vc, data_size, p_data);
		data_offeset = data_offeset + data_size + 3;
		delayUs(50);
	}
}


uint8_t panel_init_code[] = {
#if AMOLED_NT37701_CSOT667	
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x00,
	0x39, 0, 9, 0xBA,0x02,0x79,0x00,0x14,0x03,0x9C,0x00,0x01,
	0x39, 0, 2, 0x6F,0x08,
	0x39, 0, 9, 0xBA,0x01,0xAF,0x00,0x14,0x00,0x1C,0x00,0x00,
	0x39, 0, 2, 0x6F,0x10,
	0x39, 0, 8, 0xBA,0x01,0x66,0x00,0x14,0x00,0x1C,0x00,
	0x39, 0, 9, 0xBB,0x02,0x79,0x00,0x14,0x03,0x9C,0x00,0x21,
	0x39, 0, 2, 0xB5,0x84,
	0x39, 0, 2, 0x6F,0x06,
	0x39, 0, 4, 0xB5,0x2B,0x0C,0x33,
	0x39, 0, 2, 0x6F,0x0B,
	0x39, 0, 4, 0xB5,0x2B,0x23,0x33,
	0x39, 0, 2, 0x6F,0x10,
	0x39, 0, 6, 0xB5,0x0C,0x0C,0x0C,0x0C,0x0C,
	0x39, 0, 2, 0x6F,0x01,
	0x39, 0, 2, 0xB6,0x19,
	0x39, 0, 19, 0xB7,0x99,0x99,0x99,0x99,0x99,0x99,0x87,0x65,0x43,0x32,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x13,
	0x39, 0, 13, 0xB7,0x00,0x00,0x01,0x13,0x78,0x89,0x9A,0xAB,0xBC,0xCD,0xDE,0xEF,
	0x39, 0, 2, 0x6F,0x1F,
	0x39, 0, 25, 0xB7,0x08,0x31,0x66,0x8F,0xF5,0xC1,0xC2,0x33,0xFF,0x7F,0xFF,0x7F,0xFF,0x7F,0xFF,0x7F,0xFF,0x7F,0xFF,0x7F,0xFF,0x7F,0xFF,0xFF,
	0x39, 0, 3, 0xB2,0x98,0x60,
	0x39, 0, 2, 0x6F,0x09,
	0x39, 0, 2, 0xB2,0x40,
	0x39, 0, 2, 0x6F,0x0F,
	0x39, 0, 9, 0xB2,0x20,0x20,0x21,0xC2,0x21,0xC2,0x2F,0xFF,
	0x39, 0, 13, 0xB3,0x00,0x08,0x00,0x1C,0x00,0x1C,0x00,0x3C,0x00,0x3C,0x00,0x70,
	0x39, 0, 2, 0x6F,0x0C,
	0x39, 0, 13, 0xB3,0x00,0x70,0x00,0xC8,0x00,0xC8,0x01,0x48,0x01,0x48,0x01,0xAD,
	0x39, 0, 2, 0x6F,0x18,
	0x39, 0, 13, 0xB3,0x01,0xAD,0x01,0xC2,0x01,0xC2,0x01,0xC2,0x07,0xFF,0x0F,0xFF,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 9, 0xB3,0x01,0x55,0x08,0xCC,0x08,0xCC,0x0F,0xFF,
	0x39, 0, 2, 0x6F,0x2C,
	0x39, 0, 15, 0xB3,0x09,0x90,0x08,0xDC,0x08,0x70,0x08,0x70,0x07,0xC8,0x07,0xC8,0x06,0xB8,
	0x39, 0, 2, 0x6F,0x3A,
	0x39, 0, 13, 0xB3,0x06,0xB8,0x04,0xE8,0x04,0xE8,0x02,0x48,0x02,0x48,0x00,0x38,
	0x39, 0, 2, 0x6F,0x46,
	0x39, 0, 13, 0xB3,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,
	0x39, 0, 15, 0xB4,0x0D,0x10,0x0C,0x1C,0x0B,0x88,0x0B,0x88,0x0A,0xA0,0x0A,0xA0,0x09,0x28,
	0x39, 0, 2, 0x6F,0x0E,
	0x39, 0, 13, 0xB4,0x09,0x28,0x06,0xB0,0x06,0xB0,0x03,0x18,0x03,0x18,0x00,0x48,
	0x39, 0, 2, 0x6F,0x1A,
	0x39, 0, 13, 0xB4,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x48,
	0x39, 0, 2, 0x6F,0x26,
	0x39, 0, 11, 0xB4,0x0D,0x10,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x48,
	0x39, 0, 2, 0x6F,0x30,
	0x39, 0, 15, 0xB4,0x09,0x90,0x08,0xDC,0x08,0x70,0x08,0x70,0x07,0xC8,0x07,0xC8,0x06,0xB8,
	0x39, 0, 2, 0x6F,0x3E,
	0x39, 0, 13, 0xB4,0x06,0xB8,0x04,0xE8,0x04,0xE8,0x02,0x48,0x02,0x48,0x00,0x38,
	0x39, 0, 2, 0x6F,0x4A,
	0x39, 0, 13, 0xB4,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,0x00,0x38,
	0x39, 0, 2, 0x6F,0xAC,
	0x39, 0, 21, 0xB2,0x0F,0xFF,0x0F,0xFF,0x08,0x09,0x08,0x6C,0x08,0xCA,0x09,0x24,0x09,0x79,0x09,0xCB,0x0A,0x1A,0x0A,0x66,
	0x39, 0, 2, 0x6F,0xC0,
	0x39, 0, 21, 0xB2,0x0A,0xB0,0x0A,0xF7,0x0B,0x3D,0x0B,0x80,0x0B,0xC1,0x0C,0x01,0x0C,0x40,0x0C,0x7C,0x0C,0xB8,0x0C,0xF2,
	0x39, 0, 2, 0x6F,0xD4,
	0x39, 0, 21, 0xB2,0x0D,0x2B,0x0D,0x63,0x0D,0x9A,0x0D,0xCF,0x0E,0x04,0x0E,0x38,0x0E,0x6B,0x0E,0x9D,0x0E,0xCF,0x0E,0xFF,
	0x39, 0, 2, 0x6F,0xE8,
	0x39, 0, 11, 0xB2,0x0F,0x2F,0x0F,0x5E,0x0F,0x8D,0x0F,0xBB,0x0F,0xFF,
	0x39, 0, 2, 0x6F,0x52,
	0x39, 0, 21, 0xB3,0x01,0xC2,0x01,0xC3,0x01,0xF5,0x02,0x27,0x02,0x59,0x02,0x8B,0x02,0xBD,0x02,0xEF,0x03,0x21,0x03,0x53,
	0x39, 0, 2, 0x6F,0x66,
	0x39, 0, 21, 0xB3,0x03,0x84,0x03,0xB6,0x03,0xE8,0x04,0x1A,0x04,0x4C,0x04,0x7E,0x04,0xB0,0x04,0xE2,0x05,0x14,0x05,0x46,
	0x39, 0, 2, 0x6F,0x7A,
	0x39, 0, 21, 0xB3,0x05,0x78,0x05,0xA9,0x05,0xDB,0x06,0x0D,0x06,0x3F,0x06,0x71,0x06,0xA3,0x06,0xD5,0x07,0x07,0x07,0x39,
	0x39, 0, 2, 0x6F,0x8E,
	0x39, 0, 9, 0xB3,0x07,0x6B,0x07,0x9D,0x07,0xCE,0x07,0xFF,
	0x39, 0, 3, 0xB9,0x00,0x96,
	0x39, 0, 3, 0xBD,0x04,0xB0,
	0x39, 0, 4, 0xC0,0x76,0xF3,0xC1,
	0x39, 0, 2, 0x6F,0x08,
	0x39, 0, 2, 0xC0,0x40,
	0x39, 0, 2, 0x6F,0x09,
	0x39, 0, 3, 0xC0,0x20,0x20,
	0x39, 0, 2, 0x6F,0x02,
	0x39, 0, 7, 0xC1,0x24,0x86,0x00,0x57,0x00,0x45,
	0x39, 0, 2, 0x6F,0x0A,
	0x39, 0, 3, 0xC1,0x00,0x86,
	0x39, 0, 2, 0xC5,0x05,
	0x39, 0, 2, 0x6F,0x08,
	0x39, 0, 2, 0xC3,0x00,
	0x39, 0, 15, 0xC6,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
	0x39, 0, 2, 0xCA,0x12,
	0x39, 0, 2, 0xB9,0x00,
	0x39, 0, 5, 0xBE,0x0E,0x0B,0x14,0x13,
	0x39, 0, 2, 0x6F,0x05,
	0x39, 0, 2, 0xBE,0x8A,
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x00,
	0x39, 0, 2, 0x6F,0x2A,
	0x39, 0, 2, 0xD9,0x43,
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x01,
	0x39, 0, 11, 0xB5,0x00,0xB0,0x00,0x98,0x00,0x98,0x00,0xB0,0x00,0x98,
	0x39, 0, 11, 0xB6,0x01,0x38,0x00,0xD0,0x00,0xD0,0x01,0x38,0x00,0xD0,
	0x39, 0, 13, 0xC2,0x00,0xB0,0x01,0x38,0x00,0xB0,0x01,0x38,0x00,0xB0,0x01,0x38,
	0x39, 0, 3, 0xB0,0x04,0x04,
	0x39, 0, 3, 0xB3,0x13,0x13,
	0x39, 0, 7, 0xB7,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,
	0x39, 0, 3, 0xB1,0x08,0x08,
	0x39, 0, 3, 0xB4,0x13,0x13,
	0x39, 0, 8, 0xB8,0x46,0x46,0x46,0x46,0x46,0x46,0x46,
	0x39, 0, 29, 0xB9,0x00,0x1F,0x00,0x00,0x00,0x1F,0x00,0x00,0x1F,0x00,0x00,0x1F,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x1F,0x1F,0x1F,0x1F,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 6, 0xBB,0x03,0x94,0x00,0x19,0x3C,
	0x39, 0, 2, 0x6F,0x05,
	0x39, 0, 20, 0xBB,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
	0x39, 0, 2, 0x6F,0x18,
	0x39, 0, 20, 0xBB,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
	0x39, 0, 2, 0x6F,0x2B,
	0x39, 0, 20, 0xBB,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
	0x39, 0, 2, 0x6F,0x3E,
	0x39, 0, 20, 0xBB,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
	0x39, 0, 5, 0xBA,0x10,0x10,0x10,0x10,
	0x39, 0, 3, 0xC4,0x80,0x03,
	0x39, 0, 2, 0xC7,0x01,
	0x39, 0, 3, 0xCD,0x05,0x81,
	0x39, 0, 2, 0xCF,0x1D,
	0x39, 0, 2, 0x6F,0x01,
	0x39, 0, 5, 0xCE,0x00,0x01,0x00,0x00,
	0x39, 0, 2, 0x6F,0x09,
	0x39, 0, 2, 0xD2,0x00,
	0x39, 0, 2, 0x6F,0x10,
	0x39, 0, 2, 0xD8,0x0C,
	0x39, 0, 2, 0xD9,0xAB,
	0x39, 0, 2, 0xD1,0x07,
	0x39, 0, 2, 0x6F,0x02,
	0x39, 0, 2, 0xD1,0x06,
	0x39, 0, 2, 0x6F,0x05,
	0x39, 0, 2, 0xD1,0x06,
	0x39, 0, 3, 0xD6,0x00,0x40,
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
	0x39, 0, 25, 0xB9,0x00,0x04,0x00,0x0C,0x00,0x14,0x00,0x1C,0x00,0x2C,0x00,0x3C,0x00,0x4C,0x00,0x5C,0x00,0x7C,0x00,0x9C,0x00,0xBC,0x00,0xDC,
	0x39, 0, 25, 0xBA,0x00,0xFC,0x01,0x3C,0x01,0x7C,0x01,0xBC,0x01,0xFC,0x02,0x7C,0x02,0xFC,0x03,0x7C,0x03,0xBC,0x03,0xDC,0x03,0xFC,0x03,0xFF,
	0x39, 0, 2, 0xBC,0x11,
	0x39, 0, 17, 0xBD,0x96,0x00,0x69,0x00,0x00,0x96,0x00,0x69,0xBB,0x44,0x44,0xBB,0xEE,0x11,0x11,0xEE,
	0x39, 0, 2, 0xC1,0x02,
	0x39, 0, 9, 0xC2,0x19,0x00,0x91,0x00,0x19,0x00,0x91,0x00,
	0x39, 0, 3, 0xC0,0x00,0x00,
	0x39, 0, 2, 0xCE,0x01,
	0x39, 0, 2, 0xCC,0x00,

#if 1
	///////////#1_gamma.txt///////////////

	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
	0x39, 0, 2, 0xCC,0x30,
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
	0x39, 0, 2, 0xBF,0x09,
	0x39, 0, 19, 0xB0,0x00,0x00,0x01,0xF6,0x02,0x1F,0x02,0xB0,0x03,0x53,0x03,0xC8,0x04,0x34,0x04,0x95,0x05,0x25,
	0x39, 0, 19, 0xB1,0x05,0xA7,0x06,0x11,0x06,0x70,0x06,0xCA,0x07,0x6B,0x08,0x04,0x08,0x93,0x09,0x19,0x09,0x9E,
	0x39, 0, 15, 0xB2,0x0A,0x1B,0x0A,0x94,0x0B,0x0C,0x0B,0x84,0x0C,0x04,0x0D,0x04,0x0D,0x07,
	0x39, 0, 19, 0xB3,0x00,0x00,0x01,0x96,0x01,0xB4,0x02,0x10,0x02,0x89,0x02,0xED,0x03,0x51,0x03,0xAA,0x04,0x32,
	0x39, 0, 19, 0xB4,0x04,0xAE,0x05,0x15,0x05,0x71,0x05,0xC8,0x06,0x5E,0x06,0xE5,0x07,0x62,0x07,0xD6,0x08,0x45,
	0x39, 0, 15, 0xB5,0x08,0xB2,0x09,0x1B,0x09,0x83,0x09,0xEE,0x0A,0x5D,0x0B,0x3C,0x0B,0x42,
	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0xA4,0x02,0xD3,0x03,0x6F,0x04,0x1F,0x04,0x9F,0x05,0x14,0x05,0x7C,0x06,0x18,
	0x39, 0, 19, 0xB7,0x06,0xA5,0x07,0x17,0x07,0x7E,0x07,0xE0,0x08,0x91,0x09,0x34,0x09,0xCD,0x0A,0x5D,0x0A,0xEC,
	0x39, 0, 15, 0xB8,0x0B,0x79,0x0C,0x02,0x0C,0x8A,0x0D,0x19,0x0D,0xB0,0x0E,0xDF,0x0E,0xE2,
	0x39, 0, 2, 0xBF,0x08,
	0x39, 0, 19, 0xB0,0x00,0x00,0x01,0x85,0x01,0xDE,0x02,0x7F,0x02,0xFD,0x03,0x74,0x03,0xD1,0x04,0x29,0x04,0xA8,
	0x39, 0, 19, 0xB1,0x05,0x2D,0x05,0x96,0x05,0xEF,0x06,0x41,0x06,0xD6,0x07,0x6B,0x07,0xE9,0x08,0x5F,0x08,0xD4,
	0x39, 0, 15, 0xB2,0x09,0x3F,0x09,0xA8,0x0A,0x0E,0x0A,0x5F,0x0A,0xD7,0x0B,0xA0,0x0B,0xA1,
	0x39, 0, 19, 0xB3,0x00,0x00,0x01,0x3C,0x01,0x55,0x01,0xC9,0x02,0x34,0x02,0x9F,0x02,0xF6,0x03,0x46,0x03,0xCD,
	0x39, 0, 19, 0xB4,0x04,0x3F,0x04,0xA6,0x05,0x00,0x05,0x48,0x05,0xDE,0x06,0x5E,0x06,0xCF,0x07,0x39,0x07,0x9C,
	0x39, 0, 15, 0xB5,0x07,0xFD,0x08,0x55,0x08,0xAF,0x09,0x0A,0x09,0x5C,0x0A,0x07,0x0A,0x0D,
	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x12,0x02,0xA1,0x03,0x3A,0x03,0xC2,0x04,0x43,0x04,0xA9,0x05,0x07,0x05,0x99,
	0x39, 0, 19, 0xB7,0x06,0x21,0x06,0x93,0x06,0xF2,0x07,0x4B,0x07,0xED,0x08,0x8F,0x09,0x15,0x09,0x8E,0x0A,0x10,
	0x39, 0, 15, 0xB8,0x0A,0x89,0x0A,0xFB,0x0B,0x6D,0x0B,0xDC,0x0C,0x51,0x0D,0x34,0x0D,0x35,
	0x39, 0, 2, 0xBF,0x07,
	0x39, 0, 19, 0xB0,0x00,0x00,0x01,0x6F,0x01,0xBE,0x02,0x29,0x02,0x93,0x02,0xEB,0x03,0x3F,0x03,0x8B,0x04,0x09,
	0x39, 0, 19, 0xB1,0x04,0x6A,0x04,0xC4,0x05,0x20,0x05,0x6C,0x05,0xEE,0x06,0x67,0x06,0xC7,0x07,0x2C,0x07,0x8D,
	0x39, 0, 15, 0xB2,0x07,0xE5,0x08,0x37,0x08,0x89,0x08,0xDA,0x09,0x24,0x09,0xB6,0x09,0xB8,
	0x39, 0, 19, 0xB3,0x00,0x00,0x01,0x21,0x01,0x48,0x01,0x8B,0x01,0xDA,0x02,0x25,0x02,0x6F,0x02,0xB4,0x03,0x29,
	0x39, 0, 19, 0xB4,0x03,0x8B,0x03,0xE5,0x04,0x35,0x04,0x7E,0x04,0xFF,0x05,0x71,0x05,0xCE,0x06,0x28,0x06,0x7D,
	0x39, 0, 15, 0xB5,0x06,0xCB,0x07,0x15,0x07,0x5C,0x07,0xA1,0x07,0xE5,0x08,0x61,0x08,0x63,
	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x0C,0x02,0x8B,0x02,0xE8,0x03,0x50,0x03,0xAE,0x04,0x09,0x04,0x5C,0x04,0xE5,
	0x39, 0, 19, 0xB7,0x05,0x52,0x05,0xB5,0x06,0x14,0x06,0x65,0x06,0xF1,0x07,0x74,0x07,0xDD,0x08,0x4B,0x08,0xB4,
	0x39, 0, 15, 0xB8,0x09,0x11,0x09,0x65,0x09,0xBD,0x0A,0x16,0x0A,0x6A,0x0B,0x0B,0x0B,0x0D,
	0x39, 0, 2, 0xBF,0x06,
	0x39, 0, 19, 0xB0,0x00,0x00,0x00,0xE1,0x01,0x00,0x01,0x31,0x01,0xA3,0x01,0xE6,0x02,0x4B,0x02,0x93,0x03,0x01,
	0x39, 0, 19, 0xB1,0x03,0x5F,0x03,0xDD,0x04,0x21,0x04,0x60,0x04,0xE9,0x05,0x6F,0x05,0xC8,0x06,0x26,0x06,0x77,
	0x39, 0, 15, 0xB2,0x06,0xC0,0x07,0x0C,0x07,0x48,0x07,0x8A,0x07,0xCA,0x08,0x40,0x08,0x41,
	0x39, 0, 19, 0xB3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x34,0x00,0xAA,0x00,0xF4,0x01,0x4E,0x01,0x96,0x01,0xFE,
	0x39, 0, 19, 0xB4,0x02,0x66,0x02,0xDC,0x03,0x1C,0x03,0x64,0x03,0xEA,0x04,0x6A,0x04,0xBB,0x05,0x19,0x05,0x64,
	0x39, 0, 15, 0xB5,0x05,0xAD,0x05,0xF2,0x06,0x2C,0x06,0x6A,0x06,0xA4,0x07,0x12,0x07,0x13,
	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x17,0x02,0x1A,0x02,0x45,0x02,0x9A,0x02,0xDD,0x03,0x3C,0x03,0x83,0x03,0xF3,
	0x39, 0, 19, 0xB7,0x04,0x5D,0x04,0xD8,0x05,0x20,0x05,0x68,0x05,0xFA,0x06,0x7A,0x06,0xD7,0x07,0x38,0x07,0x91,
	0x39, 0, 15, 0xB8,0x07,0xDB,0x08,0x28,0x08,0x6A,0x08,0xB2,0x08,0xF8,0x09,0x73,0x09,0x76,
	0x39, 0, 2, 0xBF,0x05,
	0x39, 0, 19, 0xB0,0x00,0x00,0x00,0xEB,0x01,0x84,0x01,0xB9,0x01,0xFE,0x02,0x5B,0x02,0xA6,0x02,0xC4,0x03,0x49,
	0x39, 0, 19, 0xB1,0x03,0xB1,0x03,0xEF,0x04,0x4D,0x04,0x95,0x05,0x20,0x05,0x72,0x05,0xD6,0x06,0x26,0x06,0x77,
	0x39, 0, 15, 0xB2,0x06,0xCC,0x07,0x0C,0x07,0x51,0x07,0x89,0x07,0xCA,0x08,0x42,0x08,0x43,
	0x39, 0, 19, 0xB3,0x00,0x00,0x00,0x05,0x00,0xE3,0x01,0x38,0x01,0x5D,0x01,0xAA,0x01,0xE5,0x02,0x04,0x02,0x75,
	0x39, 0, 19, 0xB4,0x02,0xD6,0x03,0x13,0x03,0x6B,0x03,0xAF,0x04,0x2F,0x04,0x8B,0x04,0xE1,0x05,0x2E,0x05,0x7C,
	0x39, 0, 15, 0xB5,0x05,0xC7,0x05,0xFE,0x06,0x38,0x06,0x7B,0x06,0xAD,0x07,0x14,0x07,0x16,
	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x21,0x02,0x77,0x02,0x9C,0x02,0xD4,0x03,0x30,0x03,0x79,0x03,0x9D,0x04,0x27,
	0x39, 0, 19, 0xB7,0x04,0x96,0x04,0xDA,0x05,0x3E,0x05,0x82,0x06,0x18,0x06,0x7A,0x06,0xD9,0x07,0x38,0x07,0x91,
	0x39, 0, 15, 0xB8,0x07,0xE7,0x08,0x28,0x08,0x6D,0x08,0xB6,0x08,0xF8,0x09,0x75,0x09,0x78,
	0x39, 0, 2, 0xBF,0x04,
	0x39, 0, 19, 0xB0,0x00,0x00,0x01,0x8A,0x01,0xA0,0x01,0xCC,0x01,0xF3,0x02,0x2C,0x02,0x65,0x02,0x97,0x02,0xEF,
	0x39, 0, 19, 0xB1,0x03,0x43,0x03,0x8C,0x03,0xD5,0x04,0x0A,0x04,0x71,0x04,0xD8,0x05,0x28,0x05,0x78,0x05,0xBA,
	0x39, 0, 15, 0xB2,0x05,0xF7,0x06,0x36,0x06,0x75,0x06,0xA8,0x06,0xDB,0x07,0x3C,0x07,0x3D,
	0x39, 0, 19, 0xB3,0x00,0x00,0x01,0x1F,0x01,0x2F,0x01,0x4F,0x01,0x6A,0x01,0x93,0x01,0xBD,0x01,0xE7,0x02,0x30,
	0x39, 0, 19, 0xB4,0x02,0x73,0x02,0xB6,0x02,0xF9,0x03,0x2D,0x03,0x91,0x03,0xF5,0x04,0x40,0x04,0x8A,0x04,0xC6,
	0x39, 0, 15, 0xB5,0x05,0x02,0x05,0x3F,0x05,0x7C,0x05,0xAD,0x05,0xDE,0x06,0x2E,0x06,0x2F,
	0x39, 0, 19, 0xB6,0x00,0x00,0x02,0x8F,0x02,0x9F,0x02,0xC0,0x02,0xDC,0x03,0x0E,0x03,0x42,0x03,0x76,0x03,0xD3,
	0x39, 0, 19, 0xB7,0x04,0x26,0x04,0x75,0x04,0xC1,0x04,0xFE,0x05,0x6C,0x05,0xD8,0x06,0x2A,0x06,0x7B,0x06,0xBE,
	0x39, 0, 15, 0xB8,0x07,0x01,0x07,0x46,0x07,0x8B,0x07,0xC4,0x07,0xFD,0x08,0x5E,0x08,0x5F,
	0x39, 0, 2, 0xBF,0x03,
	0x39, 0, 19, 0xB0,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xA0,0x01,0xBE,0x01,0xE2,0x02,0x00,0x02,0x17,0x02,0x52,
	0x39, 0, 19, 0xB1,0x02,0x8A,0x02,0xC9,0x02,0xF9,0x03,0x2B,0x03,0x92,0x03,0xDF,0x04,0x2A,0x04,0x72,0x04,0xA9,
	0x39, 0, 15, 0xB2,0x04,0xDA,0x05,0x1A,0x05,0x44,0x05,0x7B,0x05,0xA5,0x05,0xF4,0x05,0xF5,
	0x39, 0, 19, 0xB3,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x2F,0x01,0x45,0x01,0x63,0x01,0x7B,0x01,0x87,0x01,0xB2,
	0x39, 0, 19, 0xB4,0x01,0xDC,0x02,0x0C,0x02,0x34,0x02,0x5F,0x02,0xBA,0x03,0x02,0x03,0x49,0x03,0x89,0x03,0xC8,
	0x39, 0, 15, 0xB5,0x03,0xF7,0x04,0x30,0x04,0x5D,0x04,0x85,0x04,0xB3,0x05,0x02,0x05,0x03,
	0x39, 0, 19, 0xB6,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x9F,0x02,0xB8,0x02,0xD7,0x02,0xF1,0x03,0x03,0x03,0x37,
	0x39, 0, 19, 0xB7,0x03,0x6A,0x03,0xA6,0x03,0xD8,0x04,0x0D,0x04,0x7B,0x04,0xCD,0x05,0x1C,0x05,0x65,0x05,0xA5,
	0x39, 0, 15, 0xB8,0x05,0xD6,0x06,0x1B,0x06,0x47,0x06,0x7B,0x06,0xA6,0x07,0x05,0x07,0x07,
	0x39, 0, 2, 0xBF,0x02,
	0x39, 0, 19, 0xB0,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x8F,0x01,0xA1,0x01,0xA2,0x01,0xB2,0x01,0xC0,0x01,0xDC,
	0x39, 0, 19, 0xB1,0x01,0xEB,0x02,0x02,0x02,0x1C,0x02,0x33,0x02,0x6B,0x02,0x9B,0x02,0xD1,0x02,0xFC,0x03,0x28,
	0x39, 0, 15, 0xB2,0x03,0x57,0x03,0x7A,0x03,0xA4,0x03,0xBF,0x03,0xE2,0x04,0x20,0x04,0x2A,
	0x39, 0, 19, 0xB3,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x1D,0x01,0x30,0x01,0x33,0x01,0x3F,0x01,0x4A,0x01,0x57,
	0x39, 0, 19, 0xB4,0x01,0x6A,0x01,0x7A,0x01,0x8C,0x01,0x9A,0x01,0xC3,0x01,0xE9,0x02,0x14,0x02,0x3A,0x02,0x5D,
	0x39, 0, 15, 0xB5,0x02,0x86,0x02,0xA4,0x02,0xCB,0x02,0xE9,0x03,0x07,0x03,0x43,0x03,0x4A,
	0x39, 0, 19, 0xB6,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x4F,0x02,0x75,0x02,0x9B,0x02,0xB1,0x02,0xBD,0x02,0xCD,
	0x39, 0, 19, 0xB7,0x02,0xE0,0x02,0xF4,0x03,0x0B,0x03,0x1E,0x03,0x50,0x03,0x7C,0x03,0xB0,0x03,0xDD,0x04,0x0C,
	0x39, 0, 15, 0xB8,0x04,0x3D,0x04,0x62,0x04,0x8F,0x04,0xAC,0x04,0xCF,0x05,0x11,0x05,0x1C,
	0x39, 0, 2, 0xBF,0x01,
	0x39, 0, 19, 0xB0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 19, 0xB1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 15, 0xB2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 19, 0xB3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 19, 0xB4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 15, 0xB5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 19, 0xB6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 19, 0xB7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 15, 0xB8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0xBF,0x00,
	0x39, 0, 19, 0xB0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 19, 0xB1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 15, 0xB2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 19, 0xB3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 19, 0xB4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 15, 0xB5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 19, 0xB6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 19, 0xB7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 15, 0xB8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0xCE,0x01,
	0x39, 0, 2, 0xCC,0x00,
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x02,
	0x39, 0, 25, 0xB9,0x00,0x04,0x00,0x0C,0x00,0x1C,0x00,0x2C,0x00,0x3C,0x00,0x4C,0x00,0x5C,0x00,0x7C,0x00,0x9C,0x00,0xBC,0x00,0xDC,0x00,0xFC,
	0x39, 0, 25, 0xBA,0x01,0x3C,0x01,0x7C,0x01,0xBC,0x01,0xFC,0x02,0x3C,0x02,0x7C,0x02,0xBC,0x02,0xFC,0x03,0x3C,0x03,0x7C,0x03,0xFC,0x03,0xFF,

	/////////#1_gamma.txt end///////////
#endif


	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x03,
	0x39, 0, 6, 0xB2,0x00,0x1F,0x1F,0x06,0x01,
	0x39, 0, 2, 0x6F,0x05,
	0x39, 0, 13, 0xB2,0x00,0x10,0x10,0x00,0x0F,0x0F,0x00,0x10,0x10,0x00,0x1F,0x1F,
	0x39, 0, 2, 0x6F,0x11,
	0x39, 0, 9, 0xB2,0x06,0x01,0x06,0x01,0x06,0x01,0x06,0x01,
	0x39, 0, 2, 0x6F,0x19,
	0x39, 0, 2, 0xB2,0x00,
	0x39, 0, 16, 0xB6,0xF0,0x1C,0x1C,0x00,0x10,0x01,0x00,0x10,0x01,0x00,0x10,0x01,0x00,0x1C,0x1C,
	0x39, 0, 2, 0x6F,0x0F,
	0x39, 0, 4, 0xB6,0x1F,0x00,0x0A,
	0x39, 0, 2, 0x6F,0x1A,
	0x39, 0, 4, 0xB6,0x0F,0x00,0x0A,
	0x39, 0, 2, 0x6F,0x25,
	0x39, 0, 4, 0xB6,0x0F,0x00,0x0A,
	0x39, 0, 2, 0x6F,0x30,
	0x39, 0, 4, 0xB6,0x0F,0x00,0x0A,
	0x39, 0, 17, 0xBB,0x11,0x00,0x1D,0x7E,0x00,0x0F,0x5E,0x00,0x0E,0x4C,0x00,0x00,0x00,0x00,0x1D,0x7E,
	0x39, 0, 17, 0xBC,0x22,0x10,0x1D,0x5C,0x00,0x0F,0x3C,0x00,0x0E,0x29,0x00,0x00,0x00,0x00,0x1D,0x5C,
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x04,
	0x39, 0, 2, 0xC2,0x14,
	0x39, 0, 2, 0xB1,0x02,
	0x39, 0, 2, 0xB2,0x40,
	0x39, 0, 2, 0x6F,0x01,
	0x39, 0, 4, 0xB2,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x04,
	0x39, 0, 4, 0xB2,0x09,0xE3,0x40,
	0x39, 0, 2, 0x6F,0x07,
	0x39, 0, 4, 0xB2,0x09,0xE4,0x00,
	0x39, 0, 2, 0x6F,0x0A,
	0x39, 0, 4, 0xB2,0x09,0xE3,0x40,
	0x39, 0, 2, 0xCB,0x86,
	0x39, 0, 5, 0xD0,0x00,0x00,0x00,0x10,
	0x39, 0, 2, 0x6F,0x04,
	0x39, 0, 2, 0xD0,0x01,
	0x39, 0, 2, 0x6F,0x01,
	0x39, 0, 6, 0xCB,0x05,0x0F,0x1F,0x3E,0x7C,
	0x39, 0, 2, 0x6F,0x06,
	0x39, 0, 11, 0xCB,0x00,0x08,0x00,0x3C,0x01,0x48,0x07,0xFF,0x0F,0xFF,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 6, 0xD2,0x12,0x0C,0x0C,0x0A,0x06,
	0x39, 0, 2, 0x6F,0x05,
	0x39, 0, 6, 0xD2,0x30,0x14,0x16,0x0E,0x0A,
	0x39, 0, 2, 0x6F,0x0A,
	0x39, 0, 6, 0xD2,0x48,0x20,0x16,0x12,0x0E,
	0x39, 0, 2, 0x6F,0x0F,
	0x39, 0, 6, 0xD2,0x44,0x20,0x16,0x12,0x15,
	0x39, 0, 2, 0x6F,0x14,
	0x39, 0, 6, 0xD2,0x40,0x20,0x16,0x12,0x12,
	0x39, 0, 2, 0x6F,0x19,
	0x39, 0, 6, 0xD2,0xFF,0xE4,0xA9,0x40,0x30,
	0x39, 0, 2, 0x6F,0x1E,
	0x39, 0, 6, 0xD2,0xFF,0xD8,0x40,0x26,0x20,
	0x39, 0, 2, 0x6F,0x23,
	0x39, 0, 6, 0xD2,0xFF,0x8F,0x40,0x26,0x1F,
	0x39, 0, 2, 0x6F,0x28,
	0x39, 0, 6, 0xD2,0x9F,0x60,0x40,0x20,0x1B,
	0x39, 0, 2, 0x6F,0x2D,
	0x39, 0, 6, 0xD2,0x84,0x40,0x40,0x20,0x1B,
	0x39, 0, 2, 0x6F,0x32,
	0x39, 0, 6, 0xD2,0x12,0x08,0x10,0x10,0x06,
	0x39, 0, 2, 0x6F,0x37,
	0x39, 0, 6, 0xD2,0x30,0x08,0x15,0x0B,0x0A,
	0x39, 0, 2, 0x6F,0x3C,
	0x39, 0, 6, 0xD2,0x46,0x08,0x10,0x10,0x0C,
	0x39, 0, 2, 0x6F,0x41,
	0x39, 0, 6, 0xD2,0x30,0x1A,0x10,0x16,0x16,
	0x39, 0, 2, 0x6F,0x46,
	0x39, 0, 6, 0xD2,0x30,0x1A,0x10,0x12,0x12,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 6, 0xD4,0x08,0x08,0x04,0x0C,0x06,
	0x39, 0, 2, 0x6F,0x05,
	0x39, 0, 6, 0xD4,0x29,0x18,0x10,0x0D,0x0A,
	0x39, 0, 2, 0x6F,0x0A,
	0x39, 0, 6, 0xD4,0x40,0x14,0x10,0x11,0x0C,
	0x39, 0, 2, 0x6F,0x0F,
	0x39, 0, 6, 0xD4,0x40,0x1F,0x13,0x14,0x10,
	0x39, 0, 2, 0x6F,0x14,
	0x39, 0, 6, 0xD4,0x5f,0x16,0x14,0x16,0x13,
	0x39, 0, 2, 0x6F,0x19,
	0x39, 0, 6, 0xD4,0xFF,0xFF,0xA0,0x50,0x2F,
	0x39, 0, 2, 0x6F,0x1E,
	0x39, 0, 6, 0xD4,0xFF,0xF0,0x9A,0x30,0x0C,
	0x39, 0, 2, 0x6F,0x23,
	0x39, 0, 6, 0xD4,0xFF,0xA0,0x6A,0x30,0x0F,
	0x39, 0, 2, 0x6F,0x28,
	0x39, 0, 6, 0xD4,0xF0,0x80,0x40,0x30,0x12,
	0x39, 0, 2, 0x6F,0x2D,
	0x39, 0, 6, 0xD4,0xB0,0x40,0x40,0x30,0x14,
	0x39, 0, 2, 0x6F,0x32,
	0x39, 0, 6, 0xD4,0x04,0x04,0x04,0x0A,0x05,
	0x39, 0, 2, 0x6F,0x37,
	0x39, 0, 6, 0xD4,0x32,0x14,0x10,0x0B,0x07,
	0x39, 0, 2, 0x6F,0x3C,
	0x39, 0, 6, 0xD4,0x40,0x18,0x10,0x0C,0x09,
	0x39, 0, 2, 0x6F,0x41,
	0x39, 0, 6, 0xD4,0x20,0x1C,0x1A,0x0E,0x0B,
	0x39, 0, 2, 0x6F,0x46,
	0x39, 0, 6, 0xD4,0xB5,0x18,0x18,0x08,0x0C,
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x05,
	0x39, 0, 3, 0xC7,0x07,0x01,
	0x39, 0, 4, 0xB0,0x07,0x21,0x00,
	0x39, 0, 3, 0xB3,0x86,0x80,
	0x39, 0, 3, 0xB5,0x85,0x81,
	0x39, 0, 5, 0xB7,0x85,0x00,0x00,0x81,
	0x39, 0, 5, 0xB8,0x85,0x00,0x00,0x81,
	0x39, 0, 5, 0xB9,0x85,0x00,0x00,0x81,
	0x39, 0, 4, 0xD0,0x00,0x03,0x10,
	0x39, 0, 5, 0xE0,0x82,0x00,0x00,0x02,
	0x39, 0, 4, 0xD1,0x00,0x01,0x10,
	0x39, 0, 5, 0xE1,0x82,0x00,0x00,0x02,
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x06,
	0x39, 0, 6, 0xB0,0x13,0x32,0x12,0x32,0x04,
	0x39, 0, 6, 0xB1,0x32,0x31,0x0E,0x32,0x31,
	0x39, 0, 6, 0xB2,0x32,0x00,0x32,0x31,0x32,
	0x39, 0, 2, 0xB3,0x0F,
	0x39, 0, 6, 0xB6,0x13,0x32,0x12,0x32,0x04,
	0x39, 0, 6, 0xB7,0x32,0x31,0x0E,0x32,0x31,
	0x39, 0, 6, 0xB8,0x32,0x00,0x32,0x31,0x32,
	0x39, 0, 2, 0xB9,0x0F,
	0x39, 0, 2, 0xD0,0x01,
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x07,
	0x39, 0, 2, 0xB4,0xC0,
	0x39, 0, 6, 0xB0,0x84,0xC0,0x78,0x70,0x00,
	0x39, 0, 7, 0xB1,0x0C,0x1C,0x00,0x1C,0x0C,0x00,
	0x39, 0, 2, 0xB2,0x20,
	0x39, 0, 2, 0x6F,0x36,
	0x39, 0, 2, 0xB2,0x32,
	0x39, 0, 2, 0x6F,0x3F,
	0x39, 0, 2, 0xB2,0x04,
	0x39, 0, 2, 0x6F,0x09,
	0x39, 0, 2, 0xB2,0x20,
	0x39, 0, 2, 0x6F,0x48,
	0x39, 0, 2, 0xB2,0x32,
	0x39, 0, 2, 0x6F,0x51,
	0x39, 0, 2, 0xB2,0x04,
	0x39, 0, 2, 0x6F,0x12,
	0x39, 0, 2, 0xB2,0xF0,
	0x39, 0, 2, 0x6F,0x5A,
	0x39, 0, 2, 0xB2,0x03,
	0x39, 0, 2, 0x6F,0x63,
	0x39, 0, 2, 0xB2,0x9B,
	0x39, 0, 2, 0x6F,0x1B,
	0x39, 0, 2, 0xB2,0x20,
	0x39, 0, 2, 0x6F,0x6C,
	0x39, 0, 2, 0xB2,0x32,
	0x39, 0, 2, 0x6F,0x75,
	0x39, 0, 2, 0xB2,0x04,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 2, 0xB2,0x20,
	0x39, 0, 2, 0x6F,0x7E,
	0x39, 0, 2, 0xB2,0x32,
	0x39, 0, 2, 0x6F,0x87,
	0x39, 0, 2, 0xB2,0x04,
	0x39, 0, 2, 0x6F,0x2D,
	0x39, 0, 2, 0xB2,0xCC,
	0x39, 0, 2, 0x6F,0x90,
	0x39, 0, 2, 0xB2,0x03,
	0x39, 0, 2, 0x6F,0x99,
	0x39, 0, 2, 0xB2,0x3A,
	0x39, 0, 2, 0xB4,0xC0,
	0x39, 0, 3, 0xB7,0x00,0x00,
	0x39, 0, 6, 0xC0,0x01,0x01,0x00,0x00,0x55,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xC1,0x2C,0x00,0x1C,0x39,0x1C,0x39,0x38,0x72,0x3F,0xD9,0xA2,0x84,0x40,0x00,0xE7,0x18,0x80,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xC1,0x90,0x00,0x0A,0x90,0x59,0x5F,0x33,0xE0,0x00,0x00,0x0C,0xAB,0x59,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xC1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xC2,0x2A,0x0F,0x1C,0x39,0x1C,0x39,0xC7,0x8E,0x00,0x12,0xBD,0xDA,0x40,0x14,0x86,0xBA,0xFF,0xF6,0x12,0xBF,0x8D,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xC2,0x93,0xDE,0x0A,0x94,0x37,0x5F,0x33,0xEF,0xE2,0x73,0x00,0x55,0x59,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xC2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xC3,0x26,0x00,0x1C,0x39,0x1C,0x39,0x38,0x72,0x00,0x00,0x00,0x00,0x3F,0xD8,0xBB,0x6C,0x80,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xC3,0x03,0xDE,0x00,0x04,0x37,0x55,0x33,0x60,0x00,0x00,0x03,0x55,0xA7,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xC3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xC4,0x20,0x0F,0x1C,0x39,0x1C,0x39,0xC7,0x8E,0x3F,0xEC,0x60,0x5E,0x3F,0xEC,0x5B,0x0E,0x80,0x03,0x69,0x3F,0xA9,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xC4,0x00,0x00,0x00,0x00,0x59,0x55,0x33,0x60,0x1D,0x8D,0x0F,0xAB,0xA7,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xC4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xC5,0x21,0x00,0x03,0xC1,0x03,0x49,0x00,0x00,0x3F,0xFF,0x26,0x46,0x3F,0xFF,0x34,0x52,0x00,0x00,0x0C,0x55,0x09,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xC5,0x01,0xFE,0x14,0x02,0x1B,0x33,0x33,0x80,0x03,0x83,0x0F,0xE1,0xE3,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xC5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xC6,0x27,0x00,0x03,0x84,0x03,0x49,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xFF,0x3A,0xE4,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xC6,0x02,0x1C,0x14,0x02,0x39,0x32,0x33,0x80,0x00,0x00,0x03,0x1E,0xE3,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xC6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xC7,0x2D,0x00,0x03,0x84,0x03,0x49,0x00,0x00,0x3F,0xFF,0x34,0x18,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xC7,0x01,0xFE,0x34,0x02,0x1B,0x52,0x33,0x50,0x00,0x00,0x0C,0xE2,0x1D,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xC7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xC8,0x2B,0x00,0x03,0xC1,0x03,0x49,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xF3,0xAA,0xF7,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xC8,0x02,0x1C,0x33,0x02,0x39,0x52,0x33,0x6F,0xFC,0x7D,0x00,0x1F,0x1D,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xC8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xC9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xC9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xC9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xCA,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xCA,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xCA,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xCB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xCB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xCB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xCD,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xCD,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xCD,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xCE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xCE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xCE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xCF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xCF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xCF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xD1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xD1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xD1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xD2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xD2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xD2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xD3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xD3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xD3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xD4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xD4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xD4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xD5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xD5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xD5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xD6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xD6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xD6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xD7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xD7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xD7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x00,
	0x39, 0, 22, 0xD8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x15,
	0x39, 0, 16, 0xD8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x24,
	0x39, 0, 8, 0xD8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x08,
	0x39, 0, 17, 0xB6,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,
	0x39, 0, 2, 0x6F,0x10,
	0x39, 0, 17, 0xB6,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,
	0x39, 0, 2, 0x6F,0x20,
	0x39, 0, 7, 0xB6,0x0F,0xFE,0x0F,0xFE,0x0F,0xFE,
	0x39, 0, 17, 0xB7,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 2, 0x6F,0x10,
	0x39, 0, 17, 0xB7,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 2, 0x6F,0x20,
	0x39, 0, 7, 0xB7,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 17, 0xB8,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 2, 0x6F,0x10,
	0x39, 0, 17, 0xB8,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 2, 0x6F,0x20,
	0x39, 0, 7, 0xB8,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 17, 0xB9,0x01,0x01,0x00,0x91,0x00,0x38,0x60,0x00,0x00,0x00,0xA6,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x10,
	0x39, 0, 17, 0xB9,0x00,0x00,0x00,0x00,0x01,0x00,0x05,0x00,0x0C,0x00,0x1F,0x00,0x44,0x00,0x86,0x00,
	0x39, 0, 2, 0x6F,0x20,
	0x39, 0, 17, 0xB9,0xF5,0x01,0xB3,0x02,0xD7,0x04,0x1C,0x05,0x61,0x06,0xA6,0x07,0xEB,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x30,
	0x39, 0, 17, 0xB9,0x00,0x00,0x00,0x00,0x01,0x00,0x02,0x00,0x05,0x00,0x0C,0x00,0x18,0x00,0x2C,0x00,
	0x39, 0, 2, 0x6F,0x40,
	0x39, 0, 17, 0xB9,0x4F,0x00,0xAD,0x01,0x27,0x01,0xA1,0x02,0x1B,0x02,0x95,0x03,0x0F,0x03,0x89,0x00,
	0x39, 0, 2, 0x6F,0x50,
	0x39, 0, 17, 0xB9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x0D,0x00,0x1D,0x00,
	0x39, 0, 2, 0x6F,0x60,
	0x39, 0, 17, 0xB9,0x48,0x00,0x9D,0x01,0x34,0x02,0x32,0x03,0xE4,0x05,0xF6,0x08,0xF1,0x0B,0xEC,0x0E,
	0x39, 0, 2, 0x6F,0x70,
	0x39, 0, 17, 0xB9,0xE7,0x03,0xD0,0xB0,0xE0,0x0A,0x80,0x80,0x82,0x7D,0x7B,0x79,0x77,0x72,0x70,0x80,
	0x39, 0, 2, 0x6F,0x80,
	0x39, 0, 17, 0xB9,0x80,0x80,0x7D,0x7E,0x7B,0x7B,0x77,0x73,0x80,0x80,0x82,0x81,0x80,0x7F,0x7E,0x7B,
	0x39, 0, 2, 0x6F,0x90,
	0x39, 0, 17, 0xB9,0x78,0x80,0x80,0x81,0x82,0x82,0x82,0x81,0x7F,0x7C,0x80,0x80,0x80,0x83,0x86,0x86,
	0x39, 0, 2, 0x6F,0xA0,
	0x39, 0, 17, 0xB9,0x85,0x81,0x7D,0x80,0x80,0x82,0x81,0x84,0x85,0x87,0x85,0x88,0x80,0x80,0x81,0x8B,
	0x39, 0, 2, 0x6F,0xB0,
	0x39, 0, 17, 0xB9,0x88,0x8A,0x8C,0x8D,0x8E,0x80,0x80,0x84,0x87,0x8A,0x8C,0x8F,0x90,0x91,0x80,0x80,
	0x39, 0, 2, 0x6F,0xC0,
	0x39, 0, 17, 0xB9,0x84,0x87,0x8A,0x8D,0x91,0x91,0x92,0x80,0x80,0x85,0x88,0x8D,0x8F,0x8F,0x95,0x96,
	0x39, 0, 2, 0x6F,0xD0,
	0x39, 0, 17, 0xB9,0x80,0x80,0x7A,0x73,0x6E,0x69,0x66,0x60,0x5D,0x80,0x80,0x80,0x80,0x76,0x74,0x70,
	0x39, 0, 2, 0x6F,0xE0,
	0x39, 0, 17, 0xB9,0x6C,0x6A,0x80,0x80,0x81,0x7F,0x7F,0x7C,0x7B,0x76,0x73,0x80,0x80,0x83,0x83,0x83,
	0x39, 0, 2, 0x6F,0xF0,
	0x39, 0, 14, 0xB9,0x82,0x82,0x7F,0x7C,0x80,0x80,0x82,0x84,0x85,0x84,0x87,0x83,0x80,
	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
	0x39, 0, 2, 0x6F,0x10,
	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
	0x39, 0, 2, 0x6F,0x20,
	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
	0x39, 0, 2, 0x6F,0x30,
	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
	0x39, 0, 2, 0x6F,0x40,
	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
	0x39, 0, 2, 0x6F,0x50,
	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
	0x39, 0, 2, 0x6F,0x60,
	0x39, 0, 17, 0xBA,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x05,0xD1,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 2, 0x6F,0x70,
	0x39, 0, 17, 0xBA,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 2, 0x6F,0x80,
	0x39, 0, 17, 0xBA,0x08,0x00,0x05,0x3E,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,
	0x39, 0, 2, 0x6F,0x90,
	0x39, 0, 17, 0xBA,0x07,0x36,0x07,0x36,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x05,0x3E,0x07,0x36,
	0x39, 0, 2, 0x6F,0xA0,
	0x39, 0, 17, 0xBA,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x07,0x36,0x08,0x00,
	0x39, 0, 2, 0x6F,0xB0,
	0x39, 0, 17, 0xBA,0x08,0x00,0x08,0x00,0x08,0x00,0x05,0xD1,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 2, 0x6F,0xC0,
	0x39, 0, 17, 0xBA,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 2, 0x6F,0xD0,
	0x39, 0, 17, 0xBA,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 2, 0x6F,0xE0,
	0x39, 0, 11, 0xBA,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,
	0x39, 0, 17, 0xBB,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,
	0x39, 0, 2, 0x6F,0x10,
	0x39, 0, 17, 0xBB,0x01,0x2C,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x2C,0x01,0x2C,0x01,0x2C,
	0x39, 0, 2, 0x6F,0x20,
	0x39, 0, 17, 0xBB,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x00,0x01,0x00,
	0x39, 0, 2, 0x6F,0x30,
	0x39, 0, 17, 0xBB,0x01,0x00,0x01,0x00,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,
	0x39, 0, 2, 0x6F,0x40,
	0x39, 0, 17, 0xBB,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x2C,
	0x39, 0, 2, 0x6F,0x50,
	0x39, 0, 17, 0xBB,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,0x01,0x2C,
	0x39, 0, 2, 0x6F,0x60,
	0x39, 0, 17, 0xBB,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
	0x39, 0, 2, 0x6F,0x70,
	0x39, 0, 17, 0xBB,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,
	0x39, 0, 2, 0x6F,0x80,
	0x39, 0, 17, 0xBB,0x01,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x39, 0, 2, 0x6F,0x90,
	0x39, 0, 17, 0xBB,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x10,0x10,
	0x39, 0, 2, 0x6F,0xA0,
	0x39, 0, 5, 0xBB,0x80,0x80,0x80,0x00,
	0x39, 0, 2, 0xEE,0x05,
	0x39, 0, 5, 0xFF,0xAA,0x55,0xA5,0x80,
	0x39, 0, 2, 0x6F,0x1D,
	0x39, 0, 2, 0xF2,0x05,
	0x39, 0, 5, 0x3B,0x00,0x14,0x00,0x12,
	0x39, 0, 2, 0x03,0x01,
	0x39, 0, 2, 0x90,0x02,
	0x39, 0, 19, 0x91,0x89,0x28,0x00,0x0C,0xC2,0x00,0x03,0x1C,0x01,0x7E,0x00,0x0F,0x08,0xBB,0x04,0x3D,0x10,0xF0,
	0x39, 0, 1, 0x2C,
	0x39, 0, 5, 0x51,0x07,0xFF,0x0F,0xFF,
	0x39, 0, 2, 0x53,0x20,
	0x39, 0, 1, 0x35,
	0x39, 0, 5, 0x2A,0x00,0x00,0x04,0x37,
	0x39, 0, 5, 0x2B,0x00,0x00,0x09,0x5F,
	0x39, 0, 2, 0x2F,0x01,
	
	
	//video Mode
	0x39, 0, 6, 0xF0,0x55,0xAA,0x52,0x08,0x00,
	0x39, 0, 2, 0xC0,0x77,
//	0x39, 0, 5, 0x3B,0x00,0x10,0x09,0x90,
//	0x39, 0, 2, 0x90,0x00,
//	0x05, 0, 1, 0x2C,
//	0x39, 0, 3, 0x51,0x03,0x00,
	
#endif

};
#endif


static void send_panel_init_code_1(uint32_t size, uint8_t*data,uint32_t us)
{
	uint32_t data_offeset = 0;
	uint8_t data_type;
	uint8_t vc;
	uint8_t data_size;
	uint8_t *p_data;

	while(data_offeset<size)
	{
		data_type = data[data_offeset];
		vc = data[data_offeset+1];
		data_size = data[data_offeset+2];
		p_data = &data[data_offeset+3];
		hal_dsi_tx_ctrl_write_cmd(data_type,  vc, data_size,p_data);
		data_offeset = data_offeset + data_size + 3;
		delayUs(50);
	}
}

static void init_panel(void)
{
//	uint8_t data[20] = {0};
	
    /* reset panel*/
    tx_panel_reset();

 //   hal_gpio_init_output(IO_PAD_TD_LEDPWM, IO_LVL_HIGH);
    /* enter send initial code mode*/
    hal_dsi_tx_ctrl_enter_init_panel_mode();
	
#if PANEL_INIT_CODE_ARRAY
	send_panel_init_code(sizeof(panel_init_code), panel_init_code);
	TAU_LOGD("code init");
    
//	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, 0x00, 0x01);    //01

#if USE_FIRST_CODE  
   hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH); //LED_ON  
    hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
	  hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x11);
//	hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH); //LED_ON
	delayMs(10);  //90
//	Gpio_swire_output(2, 40);  
//	delayMs(20); 
//	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x29);
//    delayMs(20);  
	
#else
	hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x11);
	hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH); //LED_ON
	delayMs(50); // 28msʱʱЩ΢50ʧ  
	//delayMs(41); // 28msʱ2650ֻ40
	Gpio_swire_output(2,58);    //58  
	delayMs(100);   //100
	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x29);
	Gpio_swire_output(2,38);//30
    delayMs(20);  
#endif

#endif

    /* exit send initial code mode*/
    hal_dsi_tx_ctrl_exit_init_panel_mode();
    delayMs(20);     //10
}



static void open_mipi_rx(void)
{
    /* TE */
    hal_gpio_set_mode(IO_PAD_AP_TE, IO_MODE_TEAR);

    if (g_rx_ctrl_handle == NULL)
    {
        /* rx   ctrl handle */
        g_rx_ctrl_handle = hal_dsi_rx_ctrl_create_handle();
    }
    /* ò */
    g_rx_ctrl_handle->base_info.src_w = INPUT_WIDTH;
    g_rx_ctrl_handle->base_info.src_h = INPUT_HEIGHT;
    g_rx_ctrl_handle->base_info.dst_w = OUTPUT_WIDTH;
    g_rx_ctrl_handle->base_info.dst_h = OUTPUT_HEIGHT;
    g_rx_ctrl_handle->base_info.src_frate = INPUT_FRAME_RATE;
    g_rx_ctrl_handle->base_info.src_mode = INPUT_DATA_MODE;
    g_rx_ctrl_handle->rx_color_mode = INPUT_COLOR_MODE;
    g_rx_ctrl_handle->rx_lanes = INPUT_MIPI_LANE_NUM;
    g_rx_ctrl_handle->rx_nonburst_models = INPUT_VIDEO_MODEL; /* ɲ */
    g_rx_ctrl_handle->rx_vc = INPUT_VC;
    g_rx_ctrl_handle->compress_en = INPUT_COMPRESS;
    g_rx_ctrl_handle->rx_hsclk_rate = INPUT_MIPI_LANE_RATE;
    g_rx_ctrl_handle->cus_dcs_entry_table = g_cus_rx_dcs_execute_table; /* ע DCSб */
    g_rx_ctrl_handle->rx_dcs_read_entry = ap_dcs_read; /* עdsc read ص,ѡ,˺Ϊʱcus_dcs_entry_tableִ */
    g_rx_ctrl_handle->pps_update_entry = pps_update_handle;
#if 1//򿪻ᵼ¿ӡϢTX
//	g_rx_ctrl_handle->pq_marginal = PQ_TYPE_5;
//	g_rx_ctrl_handle->err_handler_level = ERR_HANDLE_L1;
	g_rx_ctrl_handle->hight_performan_mode = HIGHT_PERFORMAN_L2;
#endif
    /* ǰԤPPS,  AP PPS cmdҲ */
    if (g_rx_ctrl_handle->compress_en == true)
    {
        uint8_t pps[128] = {0x11,0x00,0x00,0x89,0x30,0x80,0x09,0x60,0x04,0x38,0x00,0x1E,0x02,0x1C,0x02,0x1C,
							0x02,0x00,0x02,0x0E,0x00,0x20,0x02,0xE3,0x00,0x07,0x00,0x0C,0x03,0x50,0x03,0x64,
							0x18,0x00,0x10,0xF0,0x03,0x0C,0x20,0x00,0x06,0x0B,0x0B,0x33,0x0E,0x1C,0x2A,0x38,
							0x46,0x54,0x62,0x69,0x70,0x77,0x79,0x7B,0x7D,0x7E,0x01,0x02,0x01,0x00,0x09,0x40,
							0x09,0xBE,0x19,0xFC,0x19,0xFA,0x19,0xF8,0x1A,0x38,0x1A,0x78,0x1A,0xB6,0x2A,0xF6,
							0x2B,0x34,0x2B,0x74,0x3B,0x74,0x63,0xF4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
							0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
							0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
		
        hal_dsi_rx_ctrl_pre_init_pps(g_rx_ctrl_handle, pps, 128);
    }

    /* ʼrx ctrl */
    hal_dsi_rx_ctrl_init(g_rx_ctrl_handle);
    //*((uint32_t *)(0x40002B04)) = 1;

#ifdef USE_FOR_SUMSUNG_S20U
	hal_dsi_rx_ctrl_set_cus_sync_line(g_rx_ctrl_handle, 2400);// lss add, ˺SYNC_LIN_NUMBER
#endif
//	hal_dsi_rx_ctrl_hight_performan_mode(g_rx_ctrl_handle);
//	hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
	/* rx ctrl */
    hal_dsi_rx_ctrl_start(g_rx_ctrl_handle);
}

static void init_mipi_tx(void)
{
    if (g_tx_ctrl_handle == NULL)
    {
        g_tx_ctrl_handle = hal_dsi_tx_ctrl_create_handle();
    }
    g_tx_ctrl_handle->channel_id = OUTPUT_VC;
    g_tx_ctrl_handle->lane_num = OUTPUT_LANE_NUMBER;
    g_tx_ctrl_handle->vid_mode = OUTPUT_VIDEO_MODEL;
    g_tx_ctrl_handle->cmd_tx_type = _CMD_TYPE;
    g_tx_ctrl_handle->dpi_vsa = OUTPUT_VSA;
    g_tx_ctrl_handle->dpi_vbp = OUTPUT_VBP;
    g_tx_ctrl_handle->dpi_vfp = OUTPUT_VFP;
    g_tx_ctrl_handle->dpi_hsa = OUTPUT_HSA;
    g_tx_ctrl_handle->dpi_hbp = OUTPUT_HBP;
    g_tx_ctrl_handle->dpi_hfp = OUTPUT_HFP;
    g_tx_ctrl_handle->base_info.src_w = INPUT_WIDTH;
    g_tx_ctrl_handle->base_info.src_h = INPUT_HEIGHT;
    g_tx_ctrl_handle->base_info.dst_w = OUTPUT_WIDTH;
    g_tx_ctrl_handle->base_info.dst_h = OUTPUT_HEIGHT;
    g_tx_ctrl_handle->base_info.src_frate = INPUT_FRAME_RATE;
    g_tx_ctrl_handle->base_info.src_mode = INPUT_DATA_MODE;
//		g_tx_ctrl_handle->tx_frame_rate = 60;  //61-62
//	g_tx_ctrl_handle->lp_exit_lpdt = true;
		g_tx_ctrl_handle->tx_line_delay = 100;   //100 do800 works;
	
    hal_dsi_tx_ctrl_init(g_tx_ctrl_handle);
    /* AP ûзʱĬϵʾɫ, Ϊ0 0 0(ɫ), ɫΪdebugʹ */
#ifndef DISPLAY_ONLY
    hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0x00, 0x00);
#else
    hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0x00, 0x00);
#endif
}


static void tx_display_on(void)
{
    init_panel();

    hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
    delayMs(135); //90     ߵ
	  hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, 0x00, 0x01);    //01
	  hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x29);
	  Gpio_swire_output(2, 40);  
	//  delayMs(20); 
//	TAU_LOGD("29 send...");
}

static void swire_timer_callback(void *data)
{
#ifdef USE_FOR_SUMSUNG_S20
	if(Flag_blacklight_EN)
	{
	  hal_swire_start(12, 12, 12, 12, SWIRE_DEFAULT_NUM);
	}
	else if(s20_power_on_flag)
	{
	  hal_swire_start(12, 12, 12, 12, SWIRE_DEFAULT_NUM);
	}
	else
#endif		
	{
    hal_swire_start(12, 12, 12, 12, swire_num);
	}
}


static void disable_mipi_timer_cb(void *data)
{
#if ENABLE_TP_WAKE_UP
    g_mipi_path_off = true;
	hal_gpio_init_output(IO_PAD_TD_LEDPWM, IO_LVL_HIGH);
    /* FIXME stop more model */
    hal_dsi_tx_ctrl_stop(g_tx_ctrl_handle);
    hal_dsi_tx_ctrl_deinit(g_tx_ctrl_handle);
    hal_dsi_rx_ctrl_stop(g_rx_ctrl_handle);
    hal_dsi_rx_ctrl_deinit(g_rx_ctrl_handle);
    hal_swire_open(DISABLE);
    hal_timer_stop(SWIRE_TIMER);
    hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_LOW);
	hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_LOW);
	hal_system_set_vcc(false);
	tp_sleep_in=1;
	TAU_LOGD("disable video path \n");
#endif
}

static void soft_disable_mipi_timer_init()
{
    TAU_LOGD("soft_disable_mipi_timer_init");
    hal_timer_init(WAKE_UP_TIMER);
    hal_timer_start(WAKE_UP_TIMER, 20, disable_mipi_timer_cb, NULL);
}

#ifdef ADD_TIMER3_FUNCTION
static void soft_timer3_cb(void *data)
{
	hal_timer_start(TIMER_NUM3, 10, soft_timer3_cb, NULL);
	tp_sleep_count++;
	if(phone_DisplayOFF_count>0)
	{
		phone_DisplayOFF_count++;
	}

#if 0// test
	if (test_count)
	{
		test_count++;
	}
#endif

#if AUTO_CAL_TP 
	if (g_exit_sleep_mode)
	{
		if (g_cal_cnt > 0)
		{
			g_cal_cnt--;
			if (g_cal_cnt == 0)
			{
				g_calibration_flag = true;
				TAU_LOGD("Start cal tp!\n");
			}
		}
	}
#endif
}
#endif


#if ADD_TP_CALIBRATION

#endif

#if ENABLE_TP_WAKE_UP
#if 0
static void ap_reset_high_cb(void *data)
{
 	TAU_LOGD("ap_reset_high_cb***********\n");   
    delayMs(5);
	hal_system_set_pvd(true);
	hal_system_set_vcc(true);
	NVIC_SystemReset();
}
#endif
static void ap_reset_cb(void *data)
{
	/* лԴ */
	//    hal_gpio_set_output_data_ex(POWER_IO_B, IO_LVL_HIGH, POWER_IO_A, IO_LVL_LOW);
	/* VCC */
	TAU_LOGD("aprst................................................\n");
	hal_system_set_pvd(true);
	hal_system_set_vcc(true);
	NVIC_SystemReset();
}
#endif


void tp_heartbeat_exec(void)
{
	if (s_screen_init_complate)
	{
		if(hal_gpio_get_input_data(IO_PAD_TD_INT))
		{
			s_heartbeat = 0;
		}
		else
		{
			if(s_heartbeat < (65536/50))  // 65536*3 = 900ms  65536/50 = 6ms
			{
		        s_heartbeat ++;
		    }else
			{
		        TAU_LOGD("hb...");
		        s_heartbeat = 0;
			//	ap_tp_st_touch_software_reset();
				ap_tp_st_touch_hardware_reset();
		    }
		}
	}
}
//static uint32_t loop_count=1;
void ap_demo(void)
{
	hal_gpio_init_output(IO_PAD_TD_LEDPWM, IO_LVL_LOW);
   	hal_gpio_init_output(IO_PAD_PWMEN, IO_LVL_LOW);//LED_ON
   	hal_gpio_init_output(IO_PAD_AP_SWIRE, IO_LVL_LOW);//IO_LVL_LOW
	hal_gpio_init_output(IO_PAD_ADCIN, IO_LVL_LOW);//IO_LVL_LOW

    /* mipi rxʼ */
	app_tp_I2C_init();	
	open_mipi_rx();

	TAU_LOGD("S20U 568 CSOT667 [%s %s]", __DATE__, __TIME__);
//	TAU_LOGD("S20U 568 V100 20230713");

    /* mipi tx ʼ*/
    init_mipi_tx();
	
    /* touch ģʼ */
#ifndef DISPLAY_ONLY
	app_tp_init();
	phone_86_flag=1;
	phone_A6_flag=1;
	phone_start_flag=0;		
#endif

#ifdef ADD_TIMER3_FUNCTION
	tp_sleep_count=0;
	phone_DisplayOFF_count=1;
	hal_timer_init(TIMER_NUM3);
	hal_timer_start(TIMER_NUM3, 10, soft_timer3_cb, NULL);
#endif

    /* ʼ */
    tx_display_on();
    start_display_on = false;
    panel_display_done = true;

    hal_gpio_set_ap_reset_int(ENABLE, ap_reset_cb, DETECT_RISING_EDGE);
#ifndef DISPLAY_ONLY
    app_tp_phone_clear_reset_on();
#ifndef DISABLE_TDDI_I2C_FUNCTION
    /* TP ģͨѶʼ */
	delayMs(50);
//	printf("tp start begin\n");
	app_tp_transfer_screen_start();
//	printf("tp start end\n");
#endif
#endif
    while (1)
    {
        if(g_mipi_path_off == false){
            while (hal_dsi_rx_ctrl_dsc_async_handler(g_rx_ctrl_handle));
			
	#if ADD_TP_CALIBRATION
		tp_heartbeat_exec();
		app_tp_calibration_exec();
		ap_tp_st_touch_scan_point_record_event_exec();
	#endif	


	#if 0//绰Ϩ
		if (phone_off_flag==0)
		{
			if(Flag_blacklight_EN)
			{
				phone_off_flag =1;
				hal_dsi_tx_ctrl_write_cmd(0x39, 0, 2, 0x28, 0x00);
			}
		}
		else
		{
			if(Flag_blacklight_EN ==0)
			{
				phone_off_flag =0;
				hal_dsi_tx_ctrl_write_cmd(0x39, 0, 2, 0x29, 0x00);
			}
		}
	#endif
	}
				
	if(phone_DisplayOFF_flag==1)
	{	
		if(phone_DisplayOFF_count>800)
		{
			phone_DisplayOFF_count=0;
			phone_start_flag=1;
		}
	}
	else
	{
		if(phone_DisplayOFF_count>20)
		{
			phone_DisplayOFF_count=0;
			phone_start_flag=1;
			hal_gpio_set_output_data(IO_PAD_AP_INT, IO_LVL_LOW);//ͣ˫2~3s޴.jason_su
		}			
	}	
	app_tp_transfer_screen_int();

#ifdef USE_FOR_SUMSUNG_S20U				
	if(phone_start_flag==2)
	{
		
		S20_Start_init();
	}			
#endif	
    }
}
